/*
 *  vscsymbolcompletion.vala - Vala symbol completion library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <vala.h>
#include <gee.h>


#define VSC_TYPE_SYMBOL_COMPLETION (vsc_symbol_completion_get_type ())
#define VSC_SYMBOL_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SYMBOL_COMPLETION, VscSymbolCompletion))
#define VSC_SYMBOL_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SYMBOL_COMPLETION, VscSymbolCompletionClass))
#define VSC_IS_SYMBOL_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SYMBOL_COMPLETION))
#define VSC_IS_SYMBOL_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SYMBOL_COMPLETION))
#define VSC_SYMBOL_COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SYMBOL_COMPLETION, VscSymbolCompletionClass))

typedef struct _VscSymbolCompletion VscSymbolCompletion;
typedef struct _VscSymbolCompletionClass VscSymbolCompletionClass;
typedef struct _VscSymbolCompletionPrivate VscSymbolCompletionPrivate;

#define VSC_TYPE_PARSER_MANAGER (vsc_parser_manager_get_type ())
#define VSC_PARSER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_PARSER_MANAGER, VscParserManager))
#define VSC_PARSER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_PARSER_MANAGER, VscParserManagerClass))
#define VSC_IS_PARSER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_PARSER_MANAGER))
#define VSC_IS_PARSER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_PARSER_MANAGER))
#define VSC_PARSER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_PARSER_MANAGER, VscParserManagerClass))

typedef struct _VscParserManager VscParserManager;
typedef struct _VscParserManagerClass VscParserManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gee_collection_object_unref0(var) ((var == NULL) ? NULL : (var = (gee_collection_object_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define VSC_TYPE_SYMBOL_COMPLETION_ITEM (vsc_symbol_completion_item_get_type ())
#define VSC_SYMBOL_COMPLETION_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SYMBOL_COMPLETION_ITEM, VscSymbolCompletionItem))
#define VSC_SYMBOL_COMPLETION_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SYMBOL_COMPLETION_ITEM, VscSymbolCompletionItemClass))
#define VSC_IS_SYMBOL_COMPLETION_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SYMBOL_COMPLETION_ITEM))
#define VSC_IS_SYMBOL_COMPLETION_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SYMBOL_COMPLETION_ITEM))
#define VSC_SYMBOL_COMPLETION_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SYMBOL_COMPLETION_ITEM, VscSymbolCompletionItemClass))

typedef struct _VscSymbolCompletionItem VscSymbolCompletionItem;
typedef struct _VscSymbolCompletionItemClass VscSymbolCompletionItemClass;

#define VSC_TYPE_METHOD_LIST (vsc_method_list_get_type ())
#define VSC_METHOD_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_METHOD_LIST, VscMethodList))
#define VSC_METHOD_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_METHOD_LIST, VscMethodListClass))
#define VSC_IS_METHOD_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_METHOD_LIST))
#define VSC_IS_METHOD_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_METHOD_LIST))
#define VSC_METHOD_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_METHOD_LIST, VscMethodListClass))

typedef struct _VscMethodList VscMethodList;
typedef struct _VscMethodListClass VscMethodListClass;
#define _vala_code_visitor_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_visitor_unref (var), NULL)))

#define VSC_TYPE_SYMBOL_COMPLETION_RESULT (vsc_symbol_completion_result_get_type ())
#define VSC_SYMBOL_COMPLETION_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SYMBOL_COMPLETION_RESULT, VscSymbolCompletionResult))
#define VSC_SYMBOL_COMPLETION_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SYMBOL_COMPLETION_RESULT, VscSymbolCompletionResultClass))
#define VSC_IS_SYMBOL_COMPLETION_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SYMBOL_COMPLETION_RESULT))
#define VSC_IS_SYMBOL_COMPLETION_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SYMBOL_COMPLETION_RESULT))
#define VSC_SYMBOL_COMPLETION_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SYMBOL_COMPLETION_RESULT, VscSymbolCompletionResultClass))

typedef struct _VscSymbolCompletionResult VscSymbolCompletionResult;
typedef struct _VscSymbolCompletionResultClass VscSymbolCompletionResultClass;

#define VSC_TYPE_CLASS_LIST (vsc_class_list_get_type ())
#define VSC_CLASS_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_CLASS_LIST, VscClassList))
#define VSC_CLASS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_CLASS_LIST, VscClassListClass))
#define VSC_IS_CLASS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_CLASS_LIST))
#define VSC_IS_CLASS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_CLASS_LIST))
#define VSC_CLASS_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_CLASS_LIST, VscClassListClass))

typedef struct _VscClassList VscClassList;
typedef struct _VscClassListClass VscClassListClass;
typedef struct _VscSymbolCompletionResultPrivate VscSymbolCompletionResultPrivate;
#define _vala_code_context_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_context_unref (var), NULL)))

#define VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS (vsc_symbol_completion_filter_options_get_type ())
#define VSC_SYMBOL_COMPLETION_FILTER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS, VscSymbolCompletionFilterOptions))
#define VSC_SYMBOL_COMPLETION_FILTER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS, VscSymbolCompletionFilterOptionsClass))
#define VSC_IS_SYMBOL_COMPLETION_FILTER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS))
#define VSC_IS_SYMBOL_COMPLETION_FILTER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS))
#define VSC_SYMBOL_COMPLETION_FILTER_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS, VscSymbolCompletionFilterOptionsClass))

typedef struct _VscSymbolCompletionFilterOptions VscSymbolCompletionFilterOptions;
typedef struct _VscSymbolCompletionFilterOptionsClass VscSymbolCompletionFilterOptionsClass;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))

#define VSC_TYPE_TYPEFINDER_VISITOR (vsc_typefinder_visitor_get_type ())
#define VSC_TYPEFINDER_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_TYPEFINDER_VISITOR, VscTypeFinderVisitor))
#define VSC_TYPEFINDER_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_TYPEFINDER_VISITOR, VscTypeFinderVisitorClass))
#define VSC_IS_TYPEFINDER_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_TYPEFINDER_VISITOR))
#define VSC_IS_TYPEFINDER_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_TYPEFINDER_VISITOR))
#define VSC_TYPEFINDER_VISITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_TYPEFINDER_VISITOR, VscTypeFinderVisitorClass))

typedef struct _VscTypeFinderVisitor VscTypeFinderVisitor;
typedef struct _VscTypeFinderVisitorClass VscTypeFinderVisitorClass;
typedef struct _VscSymbolCompletionFilterOptionsPrivate VscSymbolCompletionFilterOptionsPrivate;

#define VSC_TYPE_COMPLETION_VISITOR (vsc_completion_visitor_get_type ())
#define VSC_COMPLETION_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_COMPLETION_VISITOR, VscCompletionVisitor))
#define VSC_COMPLETION_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_COMPLETION_VISITOR, VscCompletionVisitorClass))
#define VSC_IS_COMPLETION_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_COMPLETION_VISITOR))
#define VSC_IS_COMPLETION_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_COMPLETION_VISITOR))
#define VSC_COMPLETION_VISITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_COMPLETION_VISITOR, VscCompletionVisitorClass))

typedef struct _VscCompletionVisitor VscCompletionVisitor;
typedef struct _VscCompletionVisitorClass VscCompletionVisitorClass;

typedef enum  {
	VSC_SYMBOL_COMPLETION_ERROR_PACKAGE_FILE_NOT_FOUND,
	VSC_SYMBOL_COMPLETION_ERROR_PACKAGE_ALREADY_ADDED,
	VSC_SYMBOL_COMPLETION_ERROR_UNSUPPORTED_SYMBOL_TYPE,
	VSC_SYMBOL_COMPLETION_ERROR_UNSUPPORTED_TYPE,
	VSC_SYMBOL_COMPLETION_ERROR_SOURCE_BUFFER
} VscSymbolCompletionError;
#define VSC_SYMBOL_COMPLETION_ERROR vsc_symbol_completion_error_quark ()
struct _VscSymbolCompletion {
	GObject parent_instance;
	VscSymbolCompletionPrivate * priv;
};

struct _VscSymbolCompletionClass {
	GObjectClass parent_class;
};

struct _VscSymbolCompletionPrivate {
	VscParserManager* _parser;
};

struct _VscSymbolCompletionResult {
	GObject parent_instance;
	VscSymbolCompletionResultPrivate * priv;
	GeeList* properties;
	GeeList* classes;
	GeeList* interfaces;
	GeeList* structs;
	GeeList* methods;
	GeeList* fields;
	GeeList* signals;
	GeeList* others;
	GeeList* namespaces;
	GeeList* enums;
	GeeList* constants;
	GeeList* error_domains;
};

struct _VscSymbolCompletionResultClass {
	GObjectClass parent_class;
};

struct _VscSymbolCompletionFilterOptions {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VscSymbolCompletionFilterOptionsPrivate * priv;
	gboolean static_symbols;
	gboolean interface_symbols;
	gboolean constructors;
	gboolean instance_symbols;
	gboolean imported_namespaces;
	gboolean local_variables;
	gboolean error_domains;
	gboolean error_base;
	gboolean private_symbols;
	gboolean public_symbols;
	gboolean protected_symbols;
	gboolean internal_symbols;
	char* exclude_type;
};

struct _VscSymbolCompletionFilterOptionsClass {
	GTypeClass parent_class;
	void (*finalize) (VscSymbolCompletionFilterOptions *self);
};


static gpointer vsc_symbol_completion_parent_class = NULL;

GQuark vsc_symbol_completion_error_quark (void);
GType vsc_symbol_completion_get_type (void);
GType vsc_parser_manager_get_type (void);
#define VSC_SYMBOL_COMPLETION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSC_TYPE_SYMBOL_COMPLETION, VscSymbolCompletionPrivate))
enum  {
	VSC_SYMBOL_COMPLETION_DUMMY_PROPERTY,
	VSC_SYMBOL_COMPLETION_PARSER
};
VscParserManager* vsc_parser_manager_new (void);
VscParserManager* vsc_parser_manager_construct (GType object_type);
void vsc_symbol_completion_cleanup (VscSymbolCompletion* self);
static ValaSourceFile* vsc_symbol_completion_find_sourcefile (VscSymbolCompletion* self, ValaCodeContext* context, const char* sourcefile);
static ValaCodeNode* vsc_symbol_completion_find_sub_codenode (VscSymbolCompletion* self, ValaCodeNode* node, gint line, gint column, ValaCodeNode* parent_node);
static ValaClass* vsc_symbol_completion_get_class (VscSymbolCompletion* self, ValaSourceFile* source, gint line, gint column, GError** error);
static gboolean vsc_symbol_completion_node_contains_position (VscSymbolCompletion* self, ValaCodeNode* node, gint line, gint column);
static ValaCodeNode* vsc_symbol_completion_find_codenode (VscSymbolCompletion* self, ValaSourceFile* source, gint line, gint column, ValaClass** cl, ValaMethod** method, GError** error);
char* vsc_symbol_completion_get_qualified_name_for_datatype (VscSymbolCompletion* self, ValaDataType* dt);
char* vsc_symbol_completion_get_name_for_datatype (VscSymbolCompletion* self, ValaDataType* dt);
GType vsc_symbol_completion_item_get_type (void);
void vsc_parser_manager_lock_all_contexts (VscParserManager* self);
ValaCodeContext* vsc_parser_manager_get_sec_context (VscParserManager* self);
ValaCodeContext* vsc_parser_manager_get_pri_context (VscParserManager* self);
VscMethodList* vsc_method_list_new (GeeList* methods);
VscMethodList* vsc_method_list_construct (GType object_type, GeeList* methods);
GType vsc_method_list_get_type (void);
void vsc_parser_manager_unlock_all_contexts (VscParserManager* self);
GeeList* vsc_symbol_completion_get_methods_for_source (VscSymbolCompletion* self, const char* sourcefile);
VscSymbolCompletionResult* vsc_symbol_completion_result_new (void);
VscSymbolCompletionResult* vsc_symbol_completion_result_construct (GType object_type);
GType vsc_symbol_completion_result_get_type (void);
VscClassList* vsc_class_list_new (GeeList* classes);
VscClassList* vsc_class_list_construct (GType object_type, GeeList* classes);
GType vsc_class_list_get_type (void);
VscSymbolCompletionResult* vsc_symbol_completion_get_classes_for_source (VscSymbolCompletion* self, const char* sourcefile);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_namespace (ValaNamespace* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_namespace (GType object_type, ValaNamespace* item);
VscSymbolCompletionResult* vsc_symbol_completion_get_namespaces (VscSymbolCompletion* self);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_class (ValaClass* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_class (GType object_type, ValaClass* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_interface (ValaInterface* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_interface (GType object_type, ValaInterface* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_struct (ValaStruct* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_struct (GType object_type, ValaStruct* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_method (ValaMethod* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_method (GType object_type, ValaMethod* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_field (ValaField* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_field (GType object_type, ValaField* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new (const char* name);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct (GType object_type, const char* name);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_signal (ValaSignal* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_signal (GType object_type, ValaSignal* item);
gpointer vsc_symbol_completion_filter_options_ref (gpointer instance);
void vsc_symbol_completion_filter_options_unref (gpointer instance);
GParamSpec* vsc_param_spec_symbol_completion_filter_options (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void vsc_value_set_symbol_completion_filter_options (GValue* value, gpointer v_object);
gpointer vsc_value_get_symbol_completion_filter_options (const GValue* value);
GType vsc_symbol_completion_filter_options_get_type (void);
VscSymbolCompletionResult* vsc_symbol_completion_get_visible_symbols (VscSymbolCompletion* self, VscSymbolCompletionFilterOptions* options, const char* sourcefile, gint line, gint column, gboolean types_only);
static ValaDataType* vsc_symbol_completion_get_datatype_for_name (VscSymbolCompletion* self, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error);
char* vsc_symbol_completion_get_datatype_name_for_name (VscSymbolCompletion* self, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error);
void vsc_parser_manager_lock_sec_context (VscParserManager* self);
void vsc_parser_manager_unlock_sec_context (VscParserManager* self);
static ValaDataType* vsc_symbol_completion_get_datatype_for_name_with_context (VscSymbolCompletion* self, ValaCodeContext* context, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error);
void vsc_parser_manager_lock_pri_context (VscParserManager* self);
void vsc_parser_manager_unlock_pri_context (VscParserManager* self);
static ValaDataType* vsc_symbol_completion_get_datatype_for_symbolname_with_context (VscSymbolCompletion* self, ValaCodeContext* context, const char* symbolname, ValaSourceFile* source, gint line, gint column, GError** error);
static ValaDataType* vsc_symbol_completion_get_inner_symbolname_datatype (VscSymbolCompletion* self, ValaDataType* datatype, const char* fields_path, ValaSourceFile* source, GError** error);
VscTypeFinderVisitor* vsc_typefinder_visitor_new (ValaSourceFile* source, ValaCodeContext* context);
VscTypeFinderVisitor* vsc_typefinder_visitor_construct (GType object_type, ValaSourceFile* source, ValaCodeContext* context);
GType vsc_typefinder_visitor_get_type (void);
void vsc_typefinder_visitor_set_searched_typename (VscTypeFinderVisitor* self, const char* value);
ValaSymbol* vsc_typefinder_visitor_get_result (VscTypeFinderVisitor* self);
static ValaDataType* vsc_symbol_completion_symbol_to_datatype (VscSymbolCompletion* self, ValaSymbol* symbol);
static ValaBlock* vsc_symbol_completion_get_codenode_body (VscSymbolCompletion* self, ValaCodeNode* codenode);
static ValaDataType* vsc_symbol_completion_datatype_for_localvariable (VscSymbolCompletion* self, ValaCodeContext* context, ValaSourceFile* source, gint line, gint column, ValaLocalVariable* lv);
static ValaDataType* vsc_symbol_completion_get_datatype_for_name_in_code_node_with_context (VscSymbolCompletion* self, ValaCodeNode* codenode, ValaCodeContext* context, const char* symbolname, ValaSourceFile* source, gint line, gint column, GError** error);
static char* vsc_symbol_completion_normalize_typename (VscSymbolCompletion* self, const char* typename, const char* namespace_name);
static char* vsc_symbol_completion_get_qualified_namespace_name (VscSymbolCompletion* self, ValaSymbol* namespace_symbol);
VscCompletionVisitor* vsc_completion_visitor_new (VscSymbolCompletionFilterOptions* options, VscSymbolCompletionResult* results, ValaSourceFile* source, ValaCodeContext* context);
VscCompletionVisitor* vsc_completion_visitor_construct (GType object_type, VscSymbolCompletionFilterOptions* options, VscSymbolCompletionResult* results, ValaSourceFile* source, ValaCodeContext* context);
GType vsc_completion_visitor_get_type (void);
static void vsc_symbol_completion_get_completion_for_name_in_namespace_with_context (VscSymbolCompletion* self, const char* namespace_name, const char* typename, VscTypeFinderVisitor* finder, VscCompletionVisitor* completion, ValaCodeContext* context);
gint vsc_symbol_completion_result_get_count (VscSymbolCompletionResult* self);
const char* vsc_typefinder_visitor_get_searched_typename (VscTypeFinderVisitor* self);
gboolean vsc_symbol_completion_symbol_has_known_namespace (const char* name);
VscSymbolCompletionResult* vsc_symbol_completion_get_completions_for_name (VscSymbolCompletion* self, VscSymbolCompletionFilterOptions* options, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error);
void vsc_completion_visitor_integrate_completion (VscCompletionVisitor* self, ValaSymbol* symbol);
VscSymbolCompletion* vsc_symbol_completion_new (void);
VscSymbolCompletion* vsc_symbol_completion_construct (GType object_type);
VscParserManager* vsc_symbol_completion_get_parser (VscSymbolCompletion* self);
static void vsc_symbol_completion_finalize (GObject* obj);
static void vsc_symbol_completion_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



GQuark vsc_symbol_completion_error_quark (void) {
	return g_quark_from_static_string ("vsc_symbol_completion_error-quark");
}


void vsc_symbol_completion_cleanup (VscSymbolCompletion* self) {
	VscParserManager* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_parser = (_tmp0_ = NULL, _g_object_unref0 (self->priv->_parser), _tmp0_);
}


static ValaSourceFile* vsc_symbol_completion_find_sourcefile (VscSymbolCompletion* self, ValaCodeContext* context, const char* sourcefile) {
	ValaSourceFile* result;
	char* name;
	GeeList* sources;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (context != NULL, NULL);
	g_return_val_if_fail (sourcefile != NULL, NULL);
	name = NULL;
	if (!g_str_has_suffix (sourcefile, ".vala")) {
		char* _tmp0_;
		name = (_tmp0_ = g_strdup_printf ("%s.vala", sourcefile), _g_free0 (name), _tmp0_);
	} else {
		char* _tmp1_;
		name = (_tmp1_ = g_strdup (sourcefile), _g_free0 (name), _tmp1_);
	}
	sources = vala_code_context_get_source_files (context);
	if (sources != NULL) {
		{
			GeeIterator* _source_it;
			_source_it = gee_iterable_iterator ((GeeIterable*) sources);
			while (TRUE) {
				ValaSourceFile* source;
				if (!gee_iterator_next (_source_it)) {
					break;
				}
				source = (ValaSourceFile*) gee_iterator_get (_source_it);
				if (_vala_strcmp0 (vala_source_file_get_filename (source), name) == 0) {
					result = source;
					_gee_collection_object_unref0 (_source_it);
					_g_free0 (name);
					_gee_collection_object_unref0 (sources);
					return result;
				}
				_vala_source_file_unref0 (source);
			}
			_gee_collection_object_unref0 (_source_it);
		}
	}
	result = NULL;
	_g_free0 (name);
	_gee_collection_object_unref0 (sources);
	return result;
}


static gpointer _vala_code_node_ref0 (gpointer self) {
	return self ? vala_code_node_ref (self) : NULL;
}


static ValaClass* vsc_symbol_completion_get_class (VscSymbolCompletion* self, ValaSourceFile* source, gint line, gint column, GError** error) {
	ValaClass* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	{
		GeeList* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _node_it;
		_node_it = (_tmp1_ = gee_iterable_iterator ((GeeIterable*) (_tmp0_ = vala_source_file_get_nodes (source))), _gee_collection_object_unref0 (_tmp0_), _tmp1_);
		while (TRUE) {
			ValaCodeNode* node;
			if (!gee_iterator_next (_node_it)) {
				break;
			}
			node = (ValaCodeNode*) gee_iterator_get (_node_it);
			if (VALA_IS_CLASS (node)) {
				ValaClass* cl;
				cl = _vala_code_node_ref0 (VALA_CLASS (node));
				{
					GeeList* _tmp2_;
					GeeIterator* _tmp3_;
					GeeIterator* _md_it;
					_md_it = (_tmp3_ = gee_iterable_iterator ((GeeIterable*) (_tmp2_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) cl))), _gee_collection_object_unref0 (_tmp2_), _tmp3_);
					while (TRUE) {
						ValaMethod* md;
						ValaCodeNode* _tmp4_;
						gboolean _tmp5_;
						if (!gee_iterator_next (_md_it)) {
							break;
						}
						md = (ValaMethod*) gee_iterator_get (_md_it);
						if ((_tmp5_ = (_tmp4_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) md, line, column, NULL)) != NULL, _vala_code_node_unref0 (_tmp4_), _tmp5_)) {
							result = cl;
							_vala_code_node_unref0 (md);
							_gee_collection_object_unref0 (_md_it);
							_vala_code_node_unref0 (node);
							_gee_collection_object_unref0 (_node_it);
							return result;
						}
						_vala_code_node_unref0 (md);
					}
					_gee_collection_object_unref0 (_md_it);
				}
				_vala_code_node_unref0 (cl);
			}
			_vala_code_node_unref0 (node);
		}
		_gee_collection_object_unref0 (_node_it);
	}
	result = NULL;
	return result;
}


static ValaCodeNode* vsc_symbol_completion_find_sub_codenode (VscSymbolCompletion* self, ValaCodeNode* node, gint line, gint column, ValaCodeNode* parent_node) {
	ValaCodeNode* result;
	ValaCodeNode* _result_;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (node != NULL, NULL);
	_result_ = NULL;
	_tmp0_ = FALSE;
	_tmp1_ = FALSE;
	if (parent_node != NULL) {
		_tmp1_ = vala_code_node_get_parent_node (node) == NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = node != parent_node;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		vala_code_node_set_parent_node (node, parent_node);
	}
	if (VALA_IS_PROPERTY (node)) {
		ValaProperty* prop;
		prop = _vala_code_node_ref0 (VALA_PROPERTY (node));
		if (vala_property_get_get_accessor (prop) != NULL) {
			ValaCodeNode* _tmp2_;
			_result_ = (_tmp2_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_property_get_get_accessor (prop), line, column, node), _vala_code_node_unref0 (_result_), _tmp2_);
			if (_result_ != NULL) {
				result = _result_;
				_vala_code_node_unref0 (prop);
				return result;
			}
		}
		if (vala_property_get_set_accessor (prop) != NULL) {
			ValaCodeNode* _tmp3_;
			_result_ = (_tmp3_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_property_get_set_accessor (prop), line, column, node), _vala_code_node_unref0 (_result_), _tmp3_);
			if (_result_ != NULL) {
				result = _result_;
				_vala_code_node_unref0 (prop);
				return result;
			}
		}
		if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) prop, line, column)) {
			result = (ValaCodeNode*) prop;
			_vala_code_node_unref0 (_result_);
			return result;
		}
		_vala_code_node_unref0 (prop);
	} else {
		if (VALA_IS_PROPERTY_ACCESSOR (node)) {
			ValaPropertyAccessor* pa;
			pa = _vala_code_node_ref0 (VALA_PROPERTY_ACCESSOR (node));
			if (vala_property_accessor_get_body (pa) != NULL) {
				ValaCodeNode* _tmp4_;
				_result_ = (_tmp4_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_property_accessor_get_body (pa), line, column, node), _vala_code_node_unref0 (_result_), _tmp4_);
				if (_result_ != NULL) {
					result = _result_;
					_vala_code_node_unref0 (pa);
					return result;
				}
			}
			if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) pa, line, column)) {
				result = (ValaCodeNode*) pa;
				_vala_code_node_unref0 (_result_);
				return result;
			}
			_vala_code_node_unref0 (pa);
		} else {
			if (VALA_IS_CONSTRUCTOR (node)) {
				ValaConstructor* cs;
				gboolean _tmp6_;
				cs = _vala_code_node_ref0 (VALA_CONSTRUCTOR (node));
				if (vala_constructor_get_body (cs) != NULL) {
					ValaCodeNode* _tmp5_;
					_result_ = (_tmp5_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_constructor_get_body (cs), line, column, node), _vala_code_node_unref0 (_result_), _tmp5_);
					if (_result_ != NULL) {
						result = _result_;
						_vala_code_node_unref0 (cs);
						return result;
					}
				}
				_tmp6_ = FALSE;
				if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_constructor_get_body (cs), line, column)) {
					_tmp6_ = TRUE;
				} else {
					_tmp6_ = vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) cs, line, column);
				}
				if (_tmp6_) {
					result = (ValaCodeNode*) cs;
					_vala_code_node_unref0 (_result_);
					return result;
				}
				_vala_code_node_unref0 (cs);
			} else {
				if (VALA_IS_DESTRUCTOR (node)) {
					ValaDestructor* ds;
					gboolean _tmp8_;
					ds = _vala_code_node_ref0 (VALA_DESTRUCTOR (node));
					if (vala_destructor_get_body (ds) != NULL) {
						ValaCodeNode* _tmp7_;
						_result_ = (_tmp7_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_destructor_get_body (ds), line, column, node), _vala_code_node_unref0 (_result_), _tmp7_);
						if (_result_ != NULL) {
							result = _result_;
							_vala_code_node_unref0 (ds);
							return result;
						}
					}
					_tmp8_ = FALSE;
					if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_destructor_get_body (ds), line, column)) {
						_tmp8_ = TRUE;
					} else {
						_tmp8_ = vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) ds, line, column);
					}
					if (_tmp8_) {
						result = (ValaCodeNode*) ds;
						_vala_code_node_unref0 (_result_);
						return result;
					}
					_vala_code_node_unref0 (ds);
				} else {
					if (VALA_IS_METHOD (node)) {
						ValaMethod* md;
						gboolean _tmp10_;
						md = _vala_code_node_ref0 (VALA_METHOD (node));
						if (vala_method_get_body (md) != NULL) {
							ValaCodeNode* _tmp9_;
							_result_ = (_tmp9_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_method_get_body (md), line, column, node), _vala_code_node_unref0 (_result_), _tmp9_);
							if (_result_ != NULL) {
								result = _result_;
								_vala_code_node_unref0 (md);
								return result;
							}
						}
						_tmp10_ = FALSE;
						if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_method_get_body (md), line, column)) {
							_tmp10_ = TRUE;
						} else {
							_tmp10_ = vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) md, line, column);
						}
						if (_tmp10_) {
							result = (ValaCodeNode*) md;
							_vala_code_node_unref0 (_result_);
							return result;
						}
						_vala_code_node_unref0 (md);
					} else {
						if (VALA_IS_TRY_STATEMENT (node)) {
							ValaTryStatement* tr;
							tr = _vala_code_node_ref0 (VALA_TRY_STATEMENT (node));
							if (vala_try_statement_get_body (tr) != NULL) {
								ValaCodeNode* _tmp11_;
								_result_ = (_tmp11_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_try_statement_get_body (tr), line, column, (ValaCodeNode*) tr), _vala_code_node_unref0 (_result_), _tmp11_);
								if (_result_ != NULL) {
									result = _result_;
									_vala_code_node_unref0 (tr);
									return result;
								}
								if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_try_statement_get_body (tr), line, column)) {
									result = _vala_code_node_ref0 ((ValaCodeNode*) vala_try_statement_get_body (tr));
									_vala_code_node_unref0 (tr);
									_vala_code_node_unref0 (_result_);
									return result;
								}
							}
							if (vala_try_statement_get_finally_body (tr) != NULL) {
								ValaCodeNode* _tmp12_;
								_result_ = (_tmp12_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_try_statement_get_finally_body (tr), line, column, (ValaCodeNode*) tr), _vala_code_node_unref0 (_result_), _tmp12_);
								if (_result_ != NULL) {
									result = _result_;
									_vala_code_node_unref0 (tr);
									return result;
								}
								if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_try_statement_get_finally_body (tr), line, column)) {
									result = _vala_code_node_ref0 ((ValaCodeNode*) vala_try_statement_get_finally_body (tr));
									_vala_code_node_unref0 (tr);
									_vala_code_node_unref0 (_result_);
									return result;
								}
							}
							{
								GeeList* _tmp13_;
								GeeIterator* _tmp14_;
								GeeIterator* _clause_it;
								_clause_it = (_tmp14_ = gee_iterable_iterator ((GeeIterable*) (_tmp13_ = vala_try_statement_get_catch_clauses (tr))), _gee_collection_object_unref0 (_tmp13_), _tmp14_);
								while (TRUE) {
									ValaCatchClause* clause;
									ValaCodeNode* _tmp15_;
									if (!gee_iterator_next (_clause_it)) {
										break;
									}
									clause = (ValaCatchClause*) gee_iterator_get (_clause_it);
									_result_ = (_tmp15_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) clause, line, column, (ValaCodeNode*) tr), _vala_code_node_unref0 (_result_), _tmp15_);
									if (_result_ != NULL) {
										result = _result_;
										_vala_code_node_unref0 (clause);
										_gee_collection_object_unref0 (_clause_it);
										_vala_code_node_unref0 (tr);
										return result;
									}
									_vala_code_node_unref0 (clause);
								}
								_gee_collection_object_unref0 (_clause_it);
							}
							if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) tr, line, column)) {
								result = (ValaCodeNode*) tr;
								_vala_code_node_unref0 (_result_);
								return result;
							}
							_vala_code_node_unref0 (tr);
						} else {
							if (VALA_IS_CATCH_CLAUSE (node)) {
								ValaCatchClause* cc;
								gboolean _tmp17_;
								gboolean _tmp18_;
								cc = _vala_code_node_ref0 (VALA_CATCH_CLAUSE (node));
								if (vala_catch_clause_get_body (cc) != NULL) {
									ValaCodeNode* _tmp16_;
									_result_ = (_tmp16_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_catch_clause_get_body (cc), line, column, (ValaCodeNode*) cc), _vala_code_node_unref0 (_result_), _tmp16_);
									if (_result_ != NULL) {
										result = _result_;
										_vala_code_node_unref0 (cc);
										return result;
									}
								}
								_tmp17_ = FALSE;
								_tmp18_ = FALSE;
								if (vala_catch_clause_get_body (cc) != NULL) {
									_tmp18_ = vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_catch_clause_get_body (cc), line, column);
								} else {
									_tmp18_ = FALSE;
								}
								if (_tmp18_) {
									_tmp17_ = TRUE;
								} else {
									_tmp17_ = vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) cc, line, column);
								}
								if (_tmp17_) {
									result = (ValaCodeNode*) cc;
									_vala_code_node_unref0 (_result_);
									return result;
								}
								_vala_code_node_unref0 (cc);
							} else {
								if (VALA_IS_EXPRESSION_STATEMENT (node)) {
									ValaExpression* expr;
									expr = _vala_code_node_ref0 (vala_expression_statement_get_expression (VALA_EXPRESSION_STATEMENT (node)));
									if (expr != NULL) {
										ValaCodeNode* _tmp19_;
										_result_ = (_tmp19_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) expr, line, column, node), _vala_code_node_unref0 (_result_), _tmp19_);
										if (_result_ != NULL) {
											result = _result_;
											_vala_code_node_unref0 (expr);
											return result;
										}
									}
									_vala_code_node_unref0 (expr);
								} else {
									if (VALA_IS_LAMBDA_EXPRESSION (node)) {
										ValaLambdaExpression* lambda;
										lambda = _vala_code_node_ref0 (VALA_LAMBDA_EXPRESSION (node));
										if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_lambda_expression_get_statement_body (lambda), line, column)) {
											ValaCodeNode* _tmp20_;
											_result_ = (_tmp20_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_lambda_expression_get_statement_body (lambda), line, column, node), _vala_code_node_unref0 (_result_), _tmp20_);
											if (_result_ != NULL) {
												result = _result_;
												_vala_code_node_unref0 (lambda);
												return result;
											}
											result = (ValaCodeNode*) lambda;
											_vala_code_node_unref0 (_result_);
											return result;
										}
										_vala_code_node_unref0 (lambda);
									} else {
										if (VALA_IS_ASSIGNMENT (node)) {
											ValaCodeNode* _tmp21_;
											_result_ = (_tmp21_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_assignment_get_right (VALA_ASSIGNMENT (node)), line, column, node), _vala_code_node_unref0 (_result_), _tmp21_);
											if (_result_ != NULL) {
												result = _result_;
												return result;
											}
											if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_assignment_get_right (VALA_ASSIGNMENT (node)), line, column)) {
												result = _vala_code_node_ref0 (node);
												_vala_code_node_unref0 (_result_);
												return result;
											}
										} else {
											if (VALA_IS_IF_STATEMENT (node)) {
												ValaIfStatement* ifs;
												ifs = _vala_code_node_ref0 (VALA_IF_STATEMENT (node));
												if (vala_if_statement_get_true_statement (ifs) != NULL) {
													ValaCodeNode* _tmp22_;
													_result_ = (_tmp22_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_if_statement_get_true_statement (ifs), line, column, node), _vala_code_node_unref0 (_result_), _tmp22_);
													if (_result_ != NULL) {
														result = _result_;
														_vala_code_node_unref0 (ifs);
														return result;
													}
													if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_if_statement_get_true_statement (ifs), line, column)) {
														result = _vala_code_node_ref0 ((ValaCodeNode*) vala_if_statement_get_true_statement (ifs));
														_vala_code_node_unref0 (ifs);
														_vala_code_node_unref0 (_result_);
														return result;
													}
												}
												if (vala_if_statement_get_false_statement (ifs) != NULL) {
													ValaCodeNode* _tmp23_;
													_result_ = (_tmp23_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_if_statement_get_false_statement (ifs), line, column, node), _vala_code_node_unref0 (_result_), _tmp23_);
													if (_result_ != NULL) {
														result = _result_;
														_vala_code_node_unref0 (ifs);
														return result;
													}
													if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_if_statement_get_false_statement (ifs), line, column)) {
														result = _vala_code_node_ref0 ((ValaCodeNode*) vala_if_statement_get_false_statement (ifs));
														_vala_code_node_unref0 (ifs);
														_vala_code_node_unref0 (_result_);
														return result;
													}
												}
												if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) ifs, line, column)) {
													result = (ValaCodeNode*) ifs;
													_vala_code_node_unref0 (_result_);
													return result;
												}
												_vala_code_node_unref0 (ifs);
											} else {
												if (VALA_IS_FOREACH_STATEMENT (node)) {
													ValaForeachStatement* fe;
													gboolean _tmp24_;
													fe = _vala_code_node_ref0 (VALA_FOREACH_STATEMENT (node));
													_tmp24_ = FALSE;
													if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_foreach_statement_get_body (fe), line, column)) {
														_tmp24_ = TRUE;
													} else {
														_tmp24_ = vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) fe, line, column);
													}
													if (_tmp24_) {
														ValaCodeNode* _tmp25_;
														_result_ = (_tmp25_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_foreach_statement_get_body (fe), line, column, node), _vala_code_node_unref0 (_result_), _tmp25_);
														if (_result_ != NULL) {
															result = _result_;
															_vala_code_node_unref0 (fe);
															return result;
														}
														result = (ValaCodeNode*) fe;
														_vala_code_node_unref0 (_result_);
														return result;
													}
													_vala_code_node_unref0 (fe);
												} else {
													if (VALA_IS_WHILE_STATEMENT (node)) {
														ValaWhileStatement* ws;
														gboolean _tmp26_;
														ws = _vala_code_node_ref0 (VALA_WHILE_STATEMENT (node));
														_tmp26_ = FALSE;
														if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_while_statement_get_body (ws), line, column)) {
															_tmp26_ = TRUE;
														} else {
															_tmp26_ = vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) ws, line, column);
														}
														if (_tmp26_) {
															ValaCodeNode* _tmp27_;
															_result_ = (_tmp27_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_while_statement_get_body (ws), line, column, node), _vala_code_node_unref0 (_result_), _tmp27_);
															if (_result_ != NULL) {
																result = _result_;
																_vala_code_node_unref0 (ws);
																return result;
															}
															result = (ValaCodeNode*) ws;
															_vala_code_node_unref0 (_result_);
															return result;
														}
														_vala_code_node_unref0 (ws);
													} else {
														if (VALA_IS_FOR_STATEMENT (node)) {
															ValaForStatement* fs;
															gboolean _tmp28_;
															fs = _vala_code_node_ref0 (VALA_FOR_STATEMENT (node));
															_tmp28_ = FALSE;
															if (vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) vala_for_statement_get_body (fs), line, column)) {
																_tmp28_ = TRUE;
															} else {
																_tmp28_ = vsc_symbol_completion_node_contains_position (self, (ValaCodeNode*) fs, line, column);
															}
															if (_tmp28_) {
																ValaCodeNode* _tmp29_;
																_result_ = (_tmp29_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_for_statement_get_body (fs), line, column, node), _vala_code_node_unref0 (_result_), _tmp29_);
																if (_result_ != NULL) {
																	result = _result_;
																	_vala_code_node_unref0 (fs);
																	return result;
																}
																result = (ValaCodeNode*) fs;
																_vala_code_node_unref0 (_result_);
																return result;
															}
															_vala_code_node_unref0 (fs);
														} else {
															if (VALA_IS_BLOCK (node)) {
																ValaBlock* block;
																block = _vala_code_node_ref0 (VALA_BLOCK (node));
																{
																	GeeList* _tmp30_;
																	GeeIterator* _tmp31_;
																	GeeIterator* _subnode_it;
																	_subnode_it = (_tmp31_ = gee_iterable_iterator ((GeeIterable*) (_tmp30_ = vala_block_get_statements (block))), _gee_collection_object_unref0 (_tmp30_), _tmp31_);
																	while (TRUE) {
																		ValaCodeNode* subnode;
																		ValaCodeNode* _tmp32_;
																		if (!gee_iterator_next (_subnode_it)) {
																			break;
																		}
																		subnode = (ValaCodeNode*) ((ValaStatement*) gee_iterator_get (_subnode_it));
																		_result_ = (_tmp32_ = vsc_symbol_completion_find_sub_codenode (self, subnode, line, column, node), _vala_code_node_unref0 (_result_), _tmp32_);
																		if (_result_ != NULL) {
																			result = _result_;
																			_vala_code_node_unref0 (subnode);
																			_gee_collection_object_unref0 (_subnode_it);
																			_vala_code_node_unref0 (block);
																			return result;
																		}
																		_vala_code_node_unref0 (subnode);
																	}
																	_gee_collection_object_unref0 (_subnode_it);
																}
																_vala_code_node_unref0 (block);
															} else {
																gboolean _tmp33_;
																gboolean _tmp34_;
																_tmp33_ = FALSE;
																_tmp34_ = FALSE;
																if (VALA_IS_RETURN_STATEMENT (node)) {
																	_tmp34_ = TRUE;
																} else {
																	_tmp34_ = VALA_IS_DECLARATION_STATEMENT (node);
																}
																if (_tmp34_) {
																	_tmp33_ = TRUE;
																} else {
																	_tmp33_ = VALA_IS_METHOD_CALL (node);
																}
																if (_tmp33_) {
																	result = NULL;
																	_vala_code_node_unref0 (_result_);
																	return result;
																} else {
																	if (VALA_IS_CAST_EXPRESSION (node)) {
																		if (vsc_symbol_completion_node_contains_position (self, node, line, column)) {
																			result = _vala_code_node_ref0 (node);
																			_vala_code_node_unref0 (_result_);
																			return result;
																		}
																	} else {
																		g_warning ("vscsymbolcompletion.vala:290: incomplete support for %s", g_type_name (G_TYPE_FROM_INSTANCE (node)));
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	result = NULL;
	_vala_code_node_unref0 (_result_);
	return result;
}


static ValaCodeNode* vsc_symbol_completion_find_codenode (VscSymbolCompletion* self, ValaSourceFile* source, gint line, gint column, ValaClass** cl, ValaMethod** method, GError** error) {
	ValaCodeNode* result;
	ValaClass* _tmp0_;
	ValaMethod* _tmp1_;
	ValaClass* _tmp18_;
	ValaMethod* _tmp19_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	if (cl != NULL) {
		*cl = NULL;
	}
	if (method != NULL) {
		*method = NULL;
	}
	(*cl) = (_tmp0_ = NULL, _vala_code_node_unref0 ((*cl)), _tmp0_);
	(*method) = (_tmp1_ = NULL, _vala_code_node_unref0 ((*method)), _tmp1_);
	{
		GeeList* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _node_it;
		_node_it = (_tmp3_ = gee_iterable_iterator ((GeeIterable*) (_tmp2_ = vala_source_file_get_nodes (source))), _gee_collection_object_unref0 (_tmp2_), _tmp3_);
		while (TRUE) {
			ValaCodeNode* node;
			ValaCodeNode* _result_;
			ValaMethod* _tmp4_;
			if (!gee_iterator_next (_node_it)) {
				break;
			}
			node = (ValaCodeNode*) gee_iterator_get (_node_it);
			_result_ = NULL;
			(*method) = (_tmp4_ = NULL, _vala_code_node_unref0 ((*method)), _tmp4_);
			if (VALA_IS_METHOD (node)) {
				ValaMethod* _tmp5_;
				ValaCodeNode* _tmp6_;
				(*method) = (_tmp5_ = _vala_code_node_ref0 (VALA_METHOD (node)), _vala_code_node_unref0 ((*method)), _tmp5_);
				_result_ = (_tmp6_ = vsc_symbol_completion_find_sub_codenode (self, node, line, column, NULL), _vala_code_node_unref0 (_result_), _tmp6_);
				if (_result_ != NULL) {
					result = _result_;
					_vala_code_node_unref0 (node);
					_gee_collection_object_unref0 (_node_it);
					return result;
				}
			} else {
				if (VALA_IS_CLASS (node)) {
					ValaClass* _tmp7_;
					ValaMethod* _tmp14_;
					(*cl) = (_tmp7_ = _vala_code_node_ref0 (VALA_CLASS (node)), _vala_code_node_unref0 ((*cl)), _tmp7_);
					if (vala_class_get_constructor ((*cl)) != NULL) {
						ValaCodeNode* _tmp8_;
						_result_ = (_tmp8_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_class_get_constructor ((*cl)), line, column, (ValaCodeNode*) (*cl)), _vala_code_node_unref0 (_result_), _tmp8_);
						if (_result_ != NULL) {
							result = _result_;
							_vala_code_node_unref0 (node);
							_gee_collection_object_unref0 (_node_it);
							return result;
						}
					}
					if (vala_class_get_destructor ((*cl)) != NULL) {
						ValaCodeNode* _tmp9_;
						_result_ = (_tmp9_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) vala_class_get_destructor ((*cl)), line, column, (ValaCodeNode*) (*cl)), _vala_code_node_unref0 (_result_), _tmp9_);
						if (_result_ != NULL) {
							result = _result_;
							_vala_code_node_unref0 (node);
							_gee_collection_object_unref0 (_node_it);
							return result;
						}
					}
					{
						GeeList* _tmp10_;
						GeeIterator* _tmp11_;
						GeeIterator* _md_it;
						_md_it = (_tmp11_ = gee_iterable_iterator ((GeeIterable*) (_tmp10_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) (*cl)))), _gee_collection_object_unref0 (_tmp10_), _tmp11_);
						while (TRUE) {
							ValaMethod* md;
							ValaMethod* _tmp12_;
							ValaCodeNode* _tmp13_;
							if (!gee_iterator_next (_md_it)) {
								break;
							}
							md = (ValaMethod*) gee_iterator_get (_md_it);
							(*method) = (_tmp12_ = _vala_code_node_ref0 (VALA_METHOD (node)), _vala_code_node_unref0 ((*method)), _tmp12_);
							_result_ = (_tmp13_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) md, line, column, (ValaCodeNode*) (*cl)), _vala_code_node_unref0 (_result_), _tmp13_);
							if (_result_ != NULL) {
								result = _result_;
								_vala_code_node_unref0 (md);
								_gee_collection_object_unref0 (_md_it);
								_vala_code_node_unref0 (node);
								_gee_collection_object_unref0 (_node_it);
								return result;
							}
							_vala_code_node_unref0 (md);
						}
						_gee_collection_object_unref0 (_md_it);
					}
					(*method) = (_tmp14_ = NULL, _vala_code_node_unref0 ((*method)), _tmp14_);
					{
						GeeList* _tmp15_;
						GeeIterator* _tmp16_;
						GeeIterator* _prop_it;
						_prop_it = (_tmp16_ = gee_iterable_iterator ((GeeIterable*) (_tmp15_ = vala_object_type_symbol_get_properties ((ValaObjectTypeSymbol*) (*cl)))), _gee_collection_object_unref0 (_tmp15_), _tmp16_);
						while (TRUE) {
							ValaProperty* prop;
							ValaCodeNode* _tmp17_;
							if (!gee_iterator_next (_prop_it)) {
								break;
							}
							prop = (ValaProperty*) gee_iterator_get (_prop_it);
							_result_ = (_tmp17_ = vsc_symbol_completion_find_sub_codenode (self, (ValaCodeNode*) prop, line, column, (ValaCodeNode*) (*cl)), _vala_code_node_unref0 (_result_), _tmp17_);
							if (_result_ != NULL) {
								result = _result_;
								_vala_code_node_unref0 (prop);
								_gee_collection_object_unref0 (_prop_it);
								_vala_code_node_unref0 (node);
								_gee_collection_object_unref0 (_node_it);
								return result;
							}
							_vala_code_node_unref0 (prop);
						}
						_gee_collection_object_unref0 (_prop_it);
					}
				}
			}
			_vala_code_node_unref0 (node);
			_vala_code_node_unref0 (_result_);
		}
		_gee_collection_object_unref0 (_node_it);
	}
	(*cl) = (_tmp18_ = NULL, _vala_code_node_unref0 ((*cl)), _tmp18_);
	(*method) = (_tmp19_ = NULL, _vala_code_node_unref0 ((*method)), _tmp19_);
	result = NULL;
	return result;
}


char* vsc_symbol_completion_get_name_for_datatype (VscSymbolCompletion* self, ValaDataType* dt) {
	char* result;
	char* typename;
	char** _tmp1_;
	gint toks_size;
	gint toks_length1;
	char** _tmp0_;
	char** toks;
	gint count;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (dt != NULL, NULL);
	typename = vsc_symbol_completion_get_qualified_name_for_datatype (self, dt);
	toks = (_tmp1_ = _tmp0_ = g_strsplit (typename, ".", 0), toks_length1 = _vala_array_length (_tmp0_), toks_size = toks_length1, _tmp1_);
	count = 0;
	while (TRUE) {
		if (!(toks[count + 1] != NULL)) {
			break;
		}
		count++;
	}
	result = g_strdup (toks[count]);
	_g_free0 (typename);
	toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static char* string_substring (const char* self, glong offset, glong len) {
	char* result;
	glong string_length;
	const char* start;
	g_return_val_if_fail (self != NULL, NULL);
	string_length = g_utf8_strlen (self, -1);
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	start = g_utf8_offset_to_pointer (self, offset);
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
	return result;
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
	return result;
}


static char* string_replace (const char* self, const char* old, const char* replacement) {
	char* result;
	GError * _inner_error_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			goto __finally0;
		}
		_tmp2_ = g_regex_replace_literal (regex, self, (glong) (-1), 0, replacement, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			goto __finally0;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_assert_not_reached ();
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


char* vsc_symbol_completion_get_qualified_name_for_datatype (VscSymbolCompletion* self, ValaDataType* dt) {
	char* result;
	char* typename;
	gboolean _tmp3_;
	char* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (dt != NULL, NULL);
	typename = NULL;
	if (VALA_IS_CLASS_TYPE (dt)) {
		char* _tmp0_;
		typename = (_tmp0_ = vala_symbol_get_full_name ((ValaSymbol*) vala_class_type_get_class_symbol (VALA_CLASS_TYPE (dt))), _g_free0 (typename), _tmp0_);
	} else {
		char* _tmp1_;
		typename = (_tmp1_ = vala_data_type_to_qualified_string (dt, NULL), _g_free0 (typename), _tmp1_);
	}
	if (NULL == typename) {
		result = g_strdup ("");
		_g_free0 (typename);
		return result;
	}
	if (g_str_has_suffix (typename, "?")) {
		char* _tmp2_;
		typename = (_tmp2_ = string_substring (typename, (glong) 0, string_get_length (typename) - 1), _g_free0 (typename), _tmp2_);
	}
	_tmp3_ = FALSE;
	if (strstr (typename, "<") != NULL) {
		_tmp3_ = g_str_has_suffix (typename, ">");
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		char* _tmp6_;
		gint _tmp5__length1;
		char** _tmp5_;
		char** _tmp4_;
		typename = (_tmp6_ = g_strdup ((_tmp5_ = _tmp4_ = g_strsplit (typename, "<", 2), _tmp5__length1 = _vala_array_length (_tmp4_), _tmp5_)[0]), _g_free0 (typename), _tmp6_);
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
	}
	typename = (_tmp7_ = string_replace (typename, "[]", ""), _g_free0 (typename), _tmp7_);
	result = typename;
	return result;
}


GeeList* vsc_symbol_completion_get_methods_for_source (VscSymbolCompletion* self, const char* sourcefile) {
	GeeList* result;
	ValaSourceFile* source;
	GeeArrayList* results;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sourcefile != NULL, NULL);
	g_warn_if_fail (self->priv->_parser != NULL);
	source = NULL;
	results = gee_array_list_new (VSC_TYPE_SYMBOL_COMPLETION_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
	if (sourcefile != NULL) {
		ValaSourceFile* _tmp0_;
		vsc_parser_manager_lock_all_contexts (self->priv->_parser);
		source = (_tmp0_ = vsc_symbol_completion_find_sourcefile (self, vsc_parser_manager_get_sec_context (self->priv->_parser), sourcefile), _vala_source_file_unref0 (source), _tmp0_);
		if (source == NULL) {
			ValaSourceFile* _tmp1_;
			source = (_tmp1_ = vsc_symbol_completion_find_sourcefile (self, vsc_parser_manager_get_pri_context (self->priv->_parser), sourcefile), _vala_source_file_unref0 (source), _tmp1_);
		}
		if (source != NULL) {
			VscMethodList* ml;
			ml = vsc_method_list_new ((GeeList*) results);
			vala_source_file_accept (source, (ValaCodeVisitor*) ml);
			_vala_code_visitor_unref0 (ml);
		} else {
			g_warning ("vscsymbolcompletion.vala:392: get_methods_for_source: source '%s' not found", sourcefile);
		}
		vsc_parser_manager_unlock_all_contexts (self->priv->_parser);
	}
	result = (GeeList*) results;
	_vala_source_file_unref0 (source);
	return result;
}


static gpointer _gee_collection_object_ref0 (gpointer self) {
	return self ? gee_collection_object_ref (self) : NULL;
}


VscSymbolCompletionResult* vsc_symbol_completion_get_classes_for_source (VscSymbolCompletion* self, const char* sourcefile) {
	VscSymbolCompletionResult* result;
	ValaSourceFile* source;
	GeeArrayList* results;
	VscSymbolCompletionResult* _result_;
	GeeList* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sourcefile != NULL, NULL);
	g_warn_if_fail (self->priv->_parser != NULL);
	source = NULL;
	results = gee_array_list_new (VSC_TYPE_SYMBOL_COMPLETION_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
	_result_ = vsc_symbol_completion_result_new ();
	if (sourcefile != NULL) {
		ValaSourceFile* _tmp0_;
		vsc_parser_manager_lock_all_contexts (self->priv->_parser);
		source = (_tmp0_ = vsc_symbol_completion_find_sourcefile (self, vsc_parser_manager_get_sec_context (self->priv->_parser), sourcefile), _vala_source_file_unref0 (source), _tmp0_);
		if (source == NULL) {
			ValaSourceFile* _tmp1_;
			source = (_tmp1_ = vsc_symbol_completion_find_sourcefile (self, vsc_parser_manager_get_pri_context (self->priv->_parser), sourcefile), _vala_source_file_unref0 (source), _tmp1_);
		}
		if (source != NULL) {
			VscClassList* ml;
			ml = vsc_class_list_new ((GeeList*) results);
			vala_source_file_accept (source, (ValaCodeVisitor*) ml);
			_vala_code_visitor_unref0 (ml);
		} else {
			g_warning ("vscsymbolcompletion.vala:416: get_classes_for_source: source '%s' not found", sourcefile);
		}
		vsc_parser_manager_unlock_all_contexts (self->priv->_parser);
	}
	_result_->classes = (_tmp2_ = _gee_collection_object_ref0 ((GeeList*) results), _gee_collection_object_unref0 (_result_->classes), _tmp2_);
	result = _result_;
	_vala_source_file_unref0 (source);
	_gee_collection_object_unref0 (results);
	return result;
}


static gpointer _vala_code_context_ref0 (gpointer self) {
	return self ? vala_code_context_ref (self) : NULL;
}


VscSymbolCompletionResult* vsc_symbol_completion_get_namespaces (VscSymbolCompletion* self) {
	VscSymbolCompletionResult* result;
	GeeArrayList* results;
	VscSymbolCompletionResult* _result_;
	ValaCodeContext* _tmp0_;
	ValaCodeContext* context;
	GeeList* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	g_warn_if_fail (self->priv->_parser != NULL);
	results = gee_array_list_new (VSC_TYPE_SYMBOL_COMPLETION_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
	_result_ = vsc_symbol_completion_result_new ();
	vsc_parser_manager_lock_all_contexts (self->priv->_parser);
	_tmp0_ = NULL;
	if (NULL != vsc_parser_manager_get_sec_context (self->priv->_parser)) {
		_tmp0_ = vsc_parser_manager_get_sec_context (self->priv->_parser);
	} else {
		_tmp0_ = vsc_parser_manager_get_pri_context (self->priv->_parser);
	}
	context = _vala_code_context_ref0 (_tmp0_);
	if (NULL != context) {
		{
			GeeList* _tmp1_;
			GeeIterator* _tmp2_;
			GeeIterator* _ns_it;
			_ns_it = (_tmp2_ = gee_iterable_iterator ((GeeIterable*) (_tmp1_ = vala_namespace_get_namespaces (vala_code_context_get_root (context)))), _gee_collection_object_unref0 (_tmp1_), _tmp2_);
			while (TRUE) {
				ValaNamespace* ns;
				VscSymbolCompletionItem* _tmp3_;
				if (!gee_iterator_next (_ns_it)) {
					break;
				}
				ns = (ValaNamespace*) gee_iterator_get (_ns_it);
				gee_collection_add ((GeeCollection*) results, _tmp3_ = vsc_symbol_completion_item_new_with_namespace (ns));
				_g_object_unref0 (_tmp3_);
				_vala_code_node_unref0 (ns);
			}
			_gee_collection_object_unref0 (_ns_it);
		}
	}
	vsc_parser_manager_unlock_all_contexts (self->priv->_parser);
	_result_->namespaces = (_tmp4_ = _gee_collection_object_ref0 ((GeeList*) results), _gee_collection_object_unref0 (_result_->namespaces), _tmp4_);
	result = _result_;
	_gee_collection_object_unref0 (results);
	_vala_code_context_unref0 (context);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


VscSymbolCompletionResult* vsc_symbol_completion_get_visible_symbols (VscSymbolCompletion* self, VscSymbolCompletionFilterOptions* options, const char* sourcefile, gint line, gint column, gboolean types_only) {
	VscSymbolCompletionResult* result;
	GError * _inner_error_;
	VscSymbolCompletionResult* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (options != NULL, NULL);
	_inner_error_ = NULL;
	_result_ = vsc_symbol_completion_result_new ();
	if (NULL == sourcefile) {
		result = _result_;
		return result;
	}
	g_warn_if_fail (self->priv->_parser != NULL);
	vsc_parser_manager_lock_all_contexts (self->priv->_parser);
	{
		ValaSourceFile* source;
		GeeArrayList* namespaces;
		ValaClass* kl;
		ValaMethod* method;
		ValaCodeNode* _tmp9_;
		ValaMethod* _tmp8_;
		ValaCodeNode* _tmp7_;
		ValaMethod* _tmp6_;
		ValaClass* _tmp5_;
		ValaCodeNode* _tmp4_;
		ValaClass* _tmp3_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		source = vsc_symbol_completion_find_sourcefile (self, vsc_parser_manager_get_sec_context (self->priv->_parser), sourcefile);
		if (NULL == source) {
			ValaSourceFile* _tmp0_;
			source = (_tmp0_ = vsc_symbol_completion_find_sourcefile (self, vsc_parser_manager_get_pri_context (self->priv->_parser), sourcefile), _vala_source_file_unref0 (source), _tmp0_);
		}
		if (NULL == source) {
			vsc_parser_manager_unlock_all_contexts (self->priv->_parser);
			result = _g_object_ref0 (_result_);
			{
				vsc_parser_manager_unlock_all_contexts (self->priv->_parser);
			}
			_vala_source_file_unref0 (source);
			_g_object_unref0 (_result_);
			return result;
		}
		namespaces = gee_array_list_new (VALA_TYPE_NAMESPACE, (GBoxedCopyFunc) vala_code_node_ref, vala_code_node_unref, g_direct_equal);
		gee_collection_add ((GeeCollection*) namespaces, vala_code_context_get_root (vala_source_file_get_context (source)));
		{
			GeeList* _tmp1_;
			GeeIterator* _tmp2_;
			GeeIterator* _item_it;
			_item_it = (_tmp2_ = gee_iterable_iterator ((GeeIterable*) (_tmp1_ = vala_source_file_get_using_directives (source))), _gee_collection_object_unref0 (_tmp1_), _tmp2_);
			while (TRUE) {
				ValaUsingDirective* item;
				if (!gee_iterator_next (_item_it)) {
					break;
				}
				item = (ValaUsingDirective*) gee_iterator_get (_item_it);
				gee_collection_add ((GeeCollection*) namespaces, VALA_NAMESPACE (vala_using_directive_get_namespace_symbol (item)));
				_vala_code_node_unref0 (item);
			}
			_gee_collection_object_unref0 (_item_it);
		}
		kl = NULL;
		method = NULL;
		_tmp6_ = NULL;
		_tmp3_ = NULL;
		_tmp9_ = (_tmp7_ = (_tmp4_ = vsc_symbol_completion_find_codenode (self, source, line, column, &_tmp3_, &_tmp6_, &_inner_error_), kl = (_tmp5_ = _tmp3_, _vala_code_node_unref0 (kl), _tmp5_), _tmp4_), method = (_tmp8_ = _tmp6_, _vala_code_node_unref0 (method), _tmp8_), _tmp7_);
		if (_inner_error_ != NULL) {
			_vala_source_file_unref0 (source);
			_gee_collection_object_unref0 (namespaces);
			_vala_code_node_unref0 (kl);
			_vala_code_node_unref0 (method);
			goto __catch1_g_error;
			goto __finally1;
		}
		_vala_code_node_unref0 (_tmp9_);
		_tmp10_ = FALSE;
		_tmp11_ = FALSE;
		if (NULL != kl) {
			_tmp11_ = NULL != vala_symbol_get_parent_symbol ((ValaSymbol*) kl);
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			_tmp10_ = VALA_IS_NAMESPACE (vala_symbol_get_parent_symbol ((ValaSymbol*) kl));
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			gee_collection_add ((GeeCollection*) namespaces, VALA_NAMESPACE (vala_symbol_get_parent_symbol ((ValaSymbol*) kl)));
		}
		{
			GeeIterator* _ns_it;
			_ns_it = gee_iterable_iterator ((GeeIterable*) namespaces);
			while (TRUE) {
				ValaNamespace* ns;
				if (!gee_iterator_next (_ns_it)) {
					break;
				}
				ns = (ValaNamespace*) gee_iterator_get (_ns_it);
				{
					GeeList* _tmp12_;
					GeeIterator* _tmp13_;
					GeeIterator* _cl_it;
					_cl_it = (_tmp13_ = gee_iterable_iterator ((GeeIterable*) (_tmp12_ = vala_namespace_get_namespaces (ns))), _gee_collection_object_unref0 (_tmp12_), _tmp13_);
					while (TRUE) {
						ValaNamespace* cl;
						VscSymbolCompletionItem* _tmp14_;
						if (!gee_iterator_next (_cl_it)) {
							break;
						}
						cl = (ValaNamespace*) gee_iterator_get (_cl_it);
						gee_collection_add ((GeeCollection*) _result_->namespaces, _tmp14_ = vsc_symbol_completion_item_new_with_namespace (cl));
						_g_object_unref0 (_tmp14_);
						_vala_code_node_unref0 (cl);
					}
					_gee_collection_object_unref0 (_cl_it);
				}
				{
					GeeList* _tmp15_;
					GeeIterator* _tmp16_;
					GeeIterator* _cl_it;
					_cl_it = (_tmp16_ = gee_iterable_iterator ((GeeIterable*) (_tmp15_ = vala_namespace_get_classes (ns))), _gee_collection_object_unref0 (_tmp15_), _tmp16_);
					while (TRUE) {
						ValaClass* cl;
						VscSymbolCompletionItem* _tmp17_;
						if (!gee_iterator_next (_cl_it)) {
							break;
						}
						cl = (ValaClass*) gee_iterator_get (_cl_it);
						gee_collection_add ((GeeCollection*) _result_->classes, _tmp17_ = vsc_symbol_completion_item_new_with_class (cl));
						_g_object_unref0 (_tmp17_);
						_vala_code_node_unref0 (cl);
					}
					_gee_collection_object_unref0 (_cl_it);
				}
				{
					GeeList* _tmp18_;
					GeeIterator* _tmp19_;
					GeeIterator* _cl_it;
					_cl_it = (_tmp19_ = gee_iterable_iterator ((GeeIterable*) (_tmp18_ = vala_namespace_get_interfaces (ns))), _gee_collection_object_unref0 (_tmp18_), _tmp19_);
					while (TRUE) {
						ValaInterface* cl;
						VscSymbolCompletionItem* _tmp20_;
						if (!gee_iterator_next (_cl_it)) {
							break;
						}
						cl = (ValaInterface*) gee_iterator_get (_cl_it);
						gee_collection_add ((GeeCollection*) _result_->interfaces, _tmp20_ = vsc_symbol_completion_item_new_with_interface (cl));
						_g_object_unref0 (_tmp20_);
						_vala_code_node_unref0 (cl);
					}
					_gee_collection_object_unref0 (_cl_it);
				}
				{
					GeeList* _tmp21_;
					GeeIterator* _tmp22_;
					GeeIterator* _cl_it;
					_cl_it = (_tmp22_ = gee_iterable_iterator ((GeeIterable*) (_tmp21_ = vala_namespace_get_structs (ns))), _gee_collection_object_unref0 (_tmp21_), _tmp22_);
					while (TRUE) {
						ValaStruct* cl;
						VscSymbolCompletionItem* _tmp23_;
						if (!gee_iterator_next (_cl_it)) {
							break;
						}
						cl = (ValaStruct*) gee_iterator_get (_cl_it);
						gee_collection_add ((GeeCollection*) _result_->structs, _tmp23_ = vsc_symbol_completion_item_new_with_struct (cl));
						_g_object_unref0 (_tmp23_);
						_vala_code_node_unref0 (cl);
					}
					_gee_collection_object_unref0 (_cl_it);
				}
				if (!types_only) {
					{
						GeeList* _tmp24_;
						GeeIterator* _tmp25_;
						GeeIterator* _cl_it;
						_cl_it = (_tmp25_ = gee_iterable_iterator ((GeeIterable*) (_tmp24_ = vala_namespace_get_methods (ns))), _gee_collection_object_unref0 (_tmp24_), _tmp25_);
						while (TRUE) {
							ValaMethod* cl;
							VscSymbolCompletionItem* _tmp26_;
							if (!gee_iterator_next (_cl_it)) {
								break;
							}
							cl = (ValaMethod*) gee_iterator_get (_cl_it);
							gee_collection_add ((GeeCollection*) _result_->methods, _tmp26_ = vsc_symbol_completion_item_new_with_method (cl));
							_g_object_unref0 (_tmp26_);
							_vala_code_node_unref0 (cl);
						}
						_gee_collection_object_unref0 (_cl_it);
					}
					{
						GeeList* _tmp27_;
						GeeIterator* _tmp28_;
						GeeIterator* _cl_it;
						_cl_it = (_tmp28_ = gee_iterable_iterator ((GeeIterable*) (_tmp27_ = vala_namespace_get_fields (ns))), _gee_collection_object_unref0 (_tmp27_), _tmp28_);
						while (TRUE) {
							ValaField* cl;
							VscSymbolCompletionItem* _tmp29_;
							if (!gee_iterator_next (_cl_it)) {
								break;
							}
							cl = (ValaField*) gee_iterator_get (_cl_it);
							gee_collection_add ((GeeCollection*) _result_->fields, _tmp29_ = vsc_symbol_completion_item_new_with_field (cl));
							_g_object_unref0 (_tmp29_);
							_vala_code_node_unref0 (cl);
						}
						_gee_collection_object_unref0 (_cl_it);
					}
					{
						GeeList* _tmp30_;
						GeeIterator* _tmp31_;
						GeeIterator* _cl_it;
						_cl_it = (_tmp31_ = gee_iterable_iterator ((GeeIterable*) (_tmp30_ = vala_namespace_get_constants (ns))), _gee_collection_object_unref0 (_tmp30_), _tmp31_);
						while (TRUE) {
							ValaConstant* cl;
							VscSymbolCompletionItem* _tmp32_;
							if (!gee_iterator_next (_cl_it)) {
								break;
							}
							cl = (ValaConstant*) gee_iterator_get (_cl_it);
							gee_collection_add ((GeeCollection*) _result_->constants, _tmp32_ = vsc_symbol_completion_item_new (vala_symbol_get_name ((ValaSymbol*) cl)));
							_g_object_unref0 (_tmp32_);
							_vala_code_node_unref0 (cl);
						}
						_gee_collection_object_unref0 (_cl_it);
					}
					{
						GeeList* _tmp33_;
						GeeIterator* _tmp34_;
						GeeIterator* _cl_it;
						_cl_it = (_tmp34_ = gee_iterable_iterator ((GeeIterable*) (_tmp33_ = vala_namespace_get_delegates (ns))), _gee_collection_object_unref0 (_tmp33_), _tmp34_);
						while (TRUE) {
							ValaDelegate* cl;
							VscSymbolCompletionItem* _tmp35_;
							if (!gee_iterator_next (_cl_it)) {
								break;
							}
							cl = (ValaDelegate*) gee_iterator_get (_cl_it);
							gee_collection_add ((GeeCollection*) _result_->others, _tmp35_ = vsc_symbol_completion_item_new (vala_symbol_get_name ((ValaSymbol*) cl)));
							_g_object_unref0 (_tmp35_);
							_vala_code_node_unref0 (cl);
						}
						_gee_collection_object_unref0 (_cl_it);
					}
					{
						GeeList* _tmp36_;
						GeeIterator* _tmp37_;
						GeeIterator* _cl_it;
						_cl_it = (_tmp37_ = gee_iterable_iterator ((GeeIterable*) (_tmp36_ = vala_namespace_get_enums (ns))), _gee_collection_object_unref0 (_tmp36_), _tmp37_);
						while (TRUE) {
							ValaEnum* cl;
							VscSymbolCompletionItem* _tmp38_;
							if (!gee_iterator_next (_cl_it)) {
								break;
							}
							cl = (ValaEnum*) gee_iterator_get (_cl_it);
							gee_collection_add ((GeeCollection*) _result_->enums, _tmp38_ = vsc_symbol_completion_item_new (vala_symbol_get_name ((ValaSymbol*) cl)));
							_g_object_unref0 (_tmp38_);
							_vala_code_node_unref0 (cl);
						}
						_gee_collection_object_unref0 (_cl_it);
					}
					if (NULL != kl) {
						{
							GeeList* _tmp39_;
							GeeIterator* _tmp40_;
							GeeIterator* _cl_it;
							_cl_it = (_tmp40_ = gee_iterable_iterator ((GeeIterable*) (_tmp39_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) kl))), _gee_collection_object_unref0 (_tmp39_), _tmp40_);
							while (TRUE) {
								ValaMethod* cl;
								VscSymbolCompletionItem* _tmp41_;
								if (!gee_iterator_next (_cl_it)) {
									break;
								}
								cl = (ValaMethod*) gee_iterator_get (_cl_it);
								gee_collection_add ((GeeCollection*) _result_->methods, _tmp41_ = vsc_symbol_completion_item_new_with_method (cl));
								_g_object_unref0 (_tmp41_);
								_vala_code_node_unref0 (cl);
							}
							_gee_collection_object_unref0 (_cl_it);
						}
						{
							GeeList* _tmp42_;
							GeeIterator* _tmp43_;
							GeeIterator* _cl_it;
							_cl_it = (_tmp43_ = gee_iterable_iterator ((GeeIterable*) (_tmp42_ = vala_class_get_fields (kl))), _gee_collection_object_unref0 (_tmp42_), _tmp43_);
							while (TRUE) {
								ValaField* cl;
								VscSymbolCompletionItem* _tmp44_;
								if (!gee_iterator_next (_cl_it)) {
									break;
								}
								cl = (ValaField*) gee_iterator_get (_cl_it);
								gee_collection_add ((GeeCollection*) _result_->fields, _tmp44_ = vsc_symbol_completion_item_new_with_field (cl));
								_g_object_unref0 (_tmp44_);
								_vala_code_node_unref0 (cl);
							}
							_gee_collection_object_unref0 (_cl_it);
						}
						{
							GeeList* _tmp45_;
							GeeIterator* _tmp46_;
							GeeIterator* _cl_it;
							_cl_it = (_tmp46_ = gee_iterable_iterator ((GeeIterable*) (_tmp45_ = vala_class_get_constants (kl))), _gee_collection_object_unref0 (_tmp45_), _tmp46_);
							while (TRUE) {
								ValaConstant* cl;
								VscSymbolCompletionItem* _tmp47_;
								if (!gee_iterator_next (_cl_it)) {
									break;
								}
								cl = (ValaConstant*) gee_iterator_get (_cl_it);
								gee_collection_add ((GeeCollection*) _result_->constants, _tmp47_ = vsc_symbol_completion_item_new (vala_symbol_get_name ((ValaSymbol*) cl)));
								_g_object_unref0 (_tmp47_);
								_vala_code_node_unref0 (cl);
							}
							_gee_collection_object_unref0 (_cl_it);
						}
						{
							GeeList* _tmp48_;
							GeeIterator* _tmp49_;
							GeeIterator* _cl_it;
							_cl_it = (_tmp49_ = gee_iterable_iterator ((GeeIterable*) (_tmp48_ = vala_class_get_delegates (kl))), _gee_collection_object_unref0 (_tmp48_), _tmp49_);
							while (TRUE) {
								ValaDelegate* cl;
								VscSymbolCompletionItem* _tmp50_;
								if (!gee_iterator_next (_cl_it)) {
									break;
								}
								cl = (ValaDelegate*) gee_iterator_get (_cl_it);
								gee_collection_add ((GeeCollection*) _result_->others, _tmp50_ = vsc_symbol_completion_item_new (vala_symbol_get_name ((ValaSymbol*) cl)));
								_g_object_unref0 (_tmp50_);
								_vala_code_node_unref0 (cl);
							}
							_gee_collection_object_unref0 (_cl_it);
						}
						{
							GeeList* _tmp51_;
							GeeIterator* _tmp52_;
							GeeIterator* _cl_it;
							_cl_it = (_tmp52_ = gee_iterable_iterator ((GeeIterable*) (_tmp51_ = vala_namespace_get_enums (ns))), _gee_collection_object_unref0 (_tmp51_), _tmp52_);
							while (TRUE) {
								ValaEnum* cl;
								VscSymbolCompletionItem* _tmp53_;
								if (!gee_iterator_next (_cl_it)) {
									break;
								}
								cl = (ValaEnum*) gee_iterator_get (_cl_it);
								gee_collection_add ((GeeCollection*) _result_->enums, _tmp53_ = vsc_symbol_completion_item_new (vala_symbol_get_name ((ValaSymbol*) cl)));
								_g_object_unref0 (_tmp53_);
								_vala_code_node_unref0 (cl);
							}
							_gee_collection_object_unref0 (_cl_it);
						}
						{
							GeeList* _tmp54_;
							GeeIterator* _tmp55_;
							GeeIterator* _cl_it;
							_cl_it = (_tmp55_ = gee_iterable_iterator ((GeeIterable*) (_tmp54_ = vala_object_type_symbol_get_signals ((ValaObjectTypeSymbol*) kl))), _gee_collection_object_unref0 (_tmp54_), _tmp55_);
							while (TRUE) {
								ValaSignal* cl;
								VscSymbolCompletionItem* _tmp56_;
								if (!gee_iterator_next (_cl_it)) {
									break;
								}
								cl = (ValaSignal*) gee_iterator_get (_cl_it);
								gee_collection_add ((GeeCollection*) _result_->signals, _tmp56_ = vsc_symbol_completion_item_new_with_signal (cl));
								_g_object_unref0 (_tmp56_);
								_vala_code_node_unref0 (cl);
							}
							_gee_collection_object_unref0 (_cl_it);
						}
					}
				}
				_vala_code_node_unref0 (ns);
			}
			_gee_collection_object_unref0 (_ns_it);
		}
		_vala_source_file_unref0 (source);
		_gee_collection_object_unref0 (namespaces);
		_vala_code_node_unref0 (kl);
		_vala_code_node_unref0 (method);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			_inner_error_ = _g_error_copy0 (err);
			if (_inner_error_ != NULL) {
				_g_error_free0 (err);
				_g_object_unref0 (_result_);
				goto __finally1;
			}
			_g_error_free0 (err);
		}
	}
	__finally1:
	{
		vsc_parser_manager_unlock_all_contexts (self->priv->_parser);
	}
	if (_inner_error_ != NULL) {
		_g_object_unref0 (_result_);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = _result_;
	return result;
}


char* vsc_symbol_completion_get_datatype_name_for_name (VscSymbolCompletion* self, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error) {
	char* result;
	GError * _inner_error_;
	char* typename;
	GTimer* timer;
	ValaDataType* dt;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (symbolname != NULL, NULL);
	g_return_val_if_fail (sourcefile != NULL, NULL);
	_inner_error_ = NULL;
	typename = NULL;
	timer = g_timer_new ();
	g_timer_start (timer);
	dt = vsc_symbol_completion_get_datatype_for_name (self, symbolname, sourcefile, line, column, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (typename);
			_g_timer_destroy0 (timer);
			return NULL;
		} else {
			_g_free0 (typename);
			_g_timer_destroy0 (timer);
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	g_timer_stop (timer);
	if (dt != NULL) {
		char* _tmp0_;
		typename = (_tmp0_ = vsc_symbol_completion_get_qualified_name_for_datatype (self, dt), _g_free0 (typename), _tmp0_);
	}
	result = typename;
	_g_timer_destroy0 (timer);
	_vala_code_node_unref0 (dt);
	return result;
}


static ValaDataType* vsc_symbol_completion_get_datatype_for_name (VscSymbolCompletion* self, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error) {
	ValaDataType* result;
	GError * _inner_error_;
	ValaDataType* res;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (symbolname != NULL, NULL);
	g_return_val_if_fail (sourcefile != NULL, NULL);
	_inner_error_ = NULL;
	res = NULL;
	vsc_parser_manager_lock_sec_context (self->priv->_parser);
	{
		ValaDataType* _tmp0_;
		ValaDataType* _tmp1_;
		_tmp0_ = vsc_symbol_completion_get_datatype_for_name_with_context (self, vsc_parser_manager_get_sec_context (self->priv->_parser), symbolname, sourcefile, line, column, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch2_g_error;
			goto __finally2;
		}
		res = (_tmp1_ = _tmp0_, _vala_code_node_unref0 (res), _tmp1_);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			_inner_error_ = _g_error_copy0 (err);
			if (_inner_error_ != NULL) {
				_g_error_free0 (err);
				_vala_code_node_unref0 (res);
				goto __finally2;
			}
			_g_error_free0 (err);
		}
	}
	__finally2:
	{
		vsc_parser_manager_unlock_sec_context (self->priv->_parser);
	}
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
			g_propagate_error (error, _inner_error_);
			_vala_code_node_unref0 (res);
			return NULL;
		} else {
			_vala_code_node_unref0 (res);
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	if (res == NULL) {
		vsc_parser_manager_lock_pri_context (self->priv->_parser);
		{
			ValaDataType* _tmp2_;
			ValaDataType* _tmp3_;
			_tmp2_ = vsc_symbol_completion_get_datatype_for_name_with_context (self, vsc_parser_manager_get_pri_context (self->priv->_parser), symbolname, sourcefile, line, column, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
				goto __finally3;
			}
			res = (_tmp3_ = _tmp2_, _vala_code_node_unref0 (res), _tmp3_);
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				_inner_error_ = _g_error_copy0 (err);
				if (_inner_error_ != NULL) {
					_g_error_free0 (err);
					_vala_code_node_unref0 (res);
					goto __finally3;
				}
				_g_error_free0 (err);
			}
		}
		__finally3:
		{
			vsc_parser_manager_unlock_pri_context (self->priv->_parser);
		}
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
				g_propagate_error (error, _inner_error_);
				_vala_code_node_unref0 (res);
				return NULL;
			} else {
				_vala_code_node_unref0 (res);
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
	result = res;
	return result;
}


static ValaDataType* vsc_symbol_completion_get_datatype_for_name_with_context (VscSymbolCompletion* self, ValaCodeContext* context, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error) {
	ValaDataType* result;
	GError * _inner_error_;
	ValaDataType* res;
	char** _tmp1_;
	gint toks_size;
	gint toks_length1;
	char** _tmp0_;
	char** toks;
	ValaSourceFile* source;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (context != NULL, NULL);
	g_return_val_if_fail (symbolname != NULL, NULL);
	g_return_val_if_fail (sourcefile != NULL, NULL);
	_inner_error_ = NULL;
	g_warn_if_fail (self->priv->_parser != NULL);
	res = NULL;
	toks = (_tmp1_ = _tmp0_ = g_strsplit (symbolname, ".", 2), toks_length1 = _vala_array_length (_tmp0_), toks_size = toks_length1, _tmp1_);
	source = NULL;
	{
		ValaSourceFile* _tmp2_;
		source = (_tmp2_ = vsc_symbol_completion_find_sourcefile (self, context, sourcefile), _vala_source_file_unref0 (source), _tmp2_);
		if (source != NULL) {
			ValaDataType* _tmp3_;
			ValaDataType* _tmp4_;
			gboolean _tmp5_;
			_tmp3_ = vsc_symbol_completion_get_datatype_for_symbolname_with_context (self, context, toks[0], source, line, column, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch4_g_error;
				goto __finally4;
			}
			res = (_tmp4_ = _tmp3_, _vala_code_node_unref0 (res), _tmp4_);
			_tmp5_ = FALSE;
			if (res != NULL) {
				_tmp5_ = toks[1] != NULL;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				ValaDataType* _tmp6_;
				ValaDataType* _tmp7_;
				_tmp6_ = vsc_symbol_completion_get_inner_symbolname_datatype (self, res, toks[1], source, &_inner_error_);
				if (_inner_error_ != NULL) {
					goto __catch4_g_error;
					goto __finally4;
				}
				res = (_tmp7_ = _tmp6_, _vala_code_node_unref0 (res), _tmp7_);
			}
		} else {
			g_warning ("vscsymbolcompletion.vala:597: (get_datatype_for_name_with_context) no sourcefile found %s", sourcefile);
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			_inner_error_ = _g_error_copy0 (err);
			if (_inner_error_ != NULL) {
				_g_error_free0 (err);
				_vala_code_node_unref0 (res);
				toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
				_vala_source_file_unref0 (source);
				goto __finally4;
			}
			_g_error_free0 (err);
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
			g_propagate_error (error, _inner_error_);
			_vala_code_node_unref0 (res);
			toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
			_vala_source_file_unref0 (source);
			return NULL;
		} else {
			_vala_code_node_unref0 (res);
			toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
			_vala_source_file_unref0 (source);
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = res;
	toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
	_vala_source_file_unref0 (source);
	return result;
}


static ValaDataType* vsc_symbol_completion_get_inner_symbolname_datatype (VscSymbolCompletion* self, ValaDataType* datatype, const char* fields_path, ValaSourceFile* source, GError** error) {
	ValaDataType* result;
	GError * _inner_error_;
	ValaDataType* _result_;
	VscTypeFinderVisitor* finder;
	char** _tmp1_;
	gint toks_size;
	gint toks_length1;
	char** _tmp0_;
	char** toks;
	char* _tmp2_;
	char* _tmp3_;
	char* typename;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (datatype != NULL, NULL);
	g_return_val_if_fail (fields_path != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	_inner_error_ = NULL;
	_result_ = NULL;
	finder = vsc_typefinder_visitor_new (source, vsc_parser_manager_get_pri_context (self->priv->_parser));
	toks = (_tmp1_ = _tmp0_ = g_strsplit (fields_path, ".", 2), toks_length1 = _vala_array_length (_tmp0_), toks_size = toks_length1, _tmp1_);
	typename = (_tmp3_ = g_strdup_printf ("%s.%s", _tmp2_ = vsc_symbol_completion_get_name_for_datatype (self, datatype), toks[0]), _g_free0 (_tmp2_), _tmp3_);
	vsc_typefinder_visitor_set_searched_typename (finder, typename);
	if (VALA_IS_OBJECT_TYPE (datatype)) {
		ValaObjectType* obj;
		obj = _vala_code_node_ref0 (VALA_OBJECT_TYPE (datatype));
		vala_code_node_accept ((ValaCodeNode*) vala_object_type_get_type_symbol (obj), (ValaCodeVisitor*) finder);
		_vala_code_node_unref0 (obj);
	} else {
		if (VALA_IS_CLASS_TYPE (datatype)) {
			ValaClassType* cl;
			cl = _vala_code_node_ref0 (VALA_CLASS_TYPE (datatype));
			vala_code_node_accept ((ValaCodeNode*) vala_class_type_get_class_symbol (cl), (ValaCodeVisitor*) finder);
			_vala_code_node_unref0 (cl);
		} else {
			if (VALA_IS_VALUE_TYPE (datatype)) {
				ValaValueType* vl;
				vl = _vala_code_node_ref0 (VALA_VALUE_TYPE (datatype));
				vala_code_node_accept ((ValaCodeNode*) vala_value_type_get_type_symbol (vl), (ValaCodeVisitor*) finder);
				_vala_code_node_unref0 (vl);
			} else {
				vala_code_node_accept ((ValaCodeNode*) datatype, (ValaCodeVisitor*) finder);
			}
		}
	}
	if (vsc_typefinder_visitor_get_result (finder) != NULL) {
		ValaDataType* _tmp4_;
		_result_ = (_tmp4_ = vsc_symbol_completion_symbol_to_datatype (self, vsc_typefinder_visitor_get_result (finder)), _vala_code_node_unref0 (_result_), _tmp4_);
		if (toks[1] != NULL) {
			ValaDataType* _tmp5_;
			ValaDataType* _tmp6_;
			_tmp5_ = vsc_symbol_completion_get_inner_symbolname_datatype (self, _result_, toks[1], source, &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
					g_propagate_error (error, _inner_error_);
					_vala_code_node_unref0 (_result_);
					_vala_code_visitor_unref0 (finder);
					toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (typename);
					return NULL;
				} else {
					_vala_code_node_unref0 (_result_);
					_vala_code_visitor_unref0 (finder);
					toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (typename);
					g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_result_ = (_tmp6_ = _tmp5_, _vala_code_node_unref0 (_result_), _tmp6_);
		}
	}
	result = _result_;
	_vala_code_visitor_unref0 (finder);
	toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (typename);
	return result;
}


static ValaDataType* vsc_symbol_completion_symbol_to_datatype (VscSymbolCompletion* self, ValaSymbol* symbol) {
	ValaDataType* result;
	ValaDataType* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	if (symbol == NULL) {
		result = NULL;
		return result;
	}
	_result_ = NULL;
	if (VALA_IS_CLASS (symbol)) {
		ValaDataType* _tmp0_;
		_result_ = (_tmp0_ = (ValaDataType*) vala_class_type_new (VALA_CLASS (symbol)), _vala_code_node_unref0 (_result_), _tmp0_);
	} else {
		if (VALA_IS_FIELD (symbol)) {
			ValaField* field;
			ValaDataType* _tmp1_;
			field = _vala_code_node_ref0 (VALA_FIELD (symbol));
			_result_ = (_tmp1_ = _vala_code_node_ref0 (vala_field_get_field_type (field)), _vala_code_node_unref0 (_result_), _tmp1_);
			_vala_code_node_unref0 (field);
		} else {
			if (VALA_IS_PROPERTY (symbol)) {
				ValaProperty* prop;
				ValaDataType* _tmp2_;
				prop = _vala_code_node_ref0 (VALA_PROPERTY (symbol));
				_result_ = (_tmp2_ = _vala_code_node_ref0 (vala_property_get_property_type (prop)), _vala_code_node_unref0 (_result_), _tmp2_);
				_vala_code_node_unref0 (prop);
			} else {
				if (VALA_IS_STRUCT (symbol)) {
					ValaDataType* _tmp3_;
					_result_ = (_tmp3_ = (ValaDataType*) vala_struct_value_type_new (VALA_STRUCT (symbol)), _vala_code_node_unref0 (_result_), _tmp3_);
				} else {
					if (VALA_IS_METHOD (symbol)) {
						ValaMethod* method;
						ValaDataType* _tmp4_;
						method = _vala_code_node_ref0 (VALA_METHOD (symbol));
						_result_ = (_tmp4_ = _vala_code_node_ref0 (vala_method_get_return_type (method)), _vala_code_node_unref0 (_result_), _tmp4_);
						_vala_code_node_unref0 (method);
					} else {
						g_warning ("vscsymbolcompletion.vala:658: (get_datatype_for_symbol_name): unsupported type %s", g_type_name (G_TYPE_FROM_INSTANCE (symbol)));
					}
				}
			}
		}
	}
	result = _result_;
	return result;
}


static ValaBlock* vsc_symbol_completion_get_codenode_body (VscSymbolCompletion* self, ValaCodeNode* codenode) {
	ValaBlock* result;
	ValaBlock* body;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (codenode != NULL, NULL);
	body = NULL;
	if (VALA_IS_METHOD (codenode)) {
		ValaBlock* _tmp0_;
		body = (_tmp0_ = _vala_code_node_ref0 (vala_method_get_body (VALA_METHOD (codenode))), _vala_code_node_unref0 (body), _tmp0_);
	} else {
		if (VALA_IS_CREATION_METHOD (codenode)) {
			ValaBlock* _tmp1_;
			body = (_tmp1_ = _vala_code_node_ref0 (vala_constructor_get_body (VALA_CONSTRUCTOR (codenode))), _vala_code_node_unref0 (body), _tmp1_);
		} else {
			if (VALA_IS_CONSTRUCTOR (codenode)) {
				ValaBlock* _tmp2_;
				body = (_tmp2_ = _vala_code_node_ref0 (vala_constructor_get_body (VALA_CONSTRUCTOR (codenode))), _vala_code_node_unref0 (body), _tmp2_);
			} else {
				if (VALA_IS_DESTRUCTOR (codenode)) {
					ValaBlock* _tmp3_;
					body = (_tmp3_ = _vala_code_node_ref0 (vala_destructor_get_body (VALA_DESTRUCTOR (codenode))), _vala_code_node_unref0 (body), _tmp3_);
				} else {
					if (VALA_IS_LAMBDA_EXPRESSION (codenode)) {
						ValaBlock* _tmp4_;
						body = (_tmp4_ = _vala_code_node_ref0 (vala_lambda_expression_get_statement_body (VALA_LAMBDA_EXPRESSION (codenode))), _vala_code_node_unref0 (body), _tmp4_);
					} else {
						if (VALA_IS_FOREACH_STATEMENT (codenode)) {
							ValaBlock* _tmp5_;
							body = (_tmp5_ = _vala_code_node_ref0 (vala_foreach_statement_get_body (VALA_FOREACH_STATEMENT (codenode))), _vala_code_node_unref0 (body), _tmp5_);
						} else {
							if (VALA_IS_FOR_STATEMENT (codenode)) {
								ValaBlock* _tmp6_;
								body = (_tmp6_ = _vala_code_node_ref0 (vala_for_statement_get_body (VALA_FOR_STATEMENT (codenode))), _vala_code_node_unref0 (body), _tmp6_);
							} else {
								if (VALA_IS_WHILE_STATEMENT (codenode)) {
									ValaBlock* _tmp7_;
									body = (_tmp7_ = _vala_code_node_ref0 (vala_while_statement_get_body (VALA_WHILE_STATEMENT (codenode))), _vala_code_node_unref0 (body), _tmp7_);
								} else {
									if (VALA_IS_BLOCK (codenode)) {
										ValaBlock* _tmp8_;
										body = (_tmp8_ = _vala_code_node_ref0 (VALA_BLOCK (codenode)), _vala_code_node_unref0 (body), _tmp8_);
									} else {
										if (VALA_IS_CATCH_CLAUSE (codenode)) {
											ValaBlock* _tmp9_;
											body = (_tmp9_ = _vala_code_node_ref0 (vala_catch_clause_get_body (VALA_CATCH_CLAUSE (codenode))), _vala_code_node_unref0 (body), _tmp9_);
										} else {
											if (VALA_IS_PROPERTY_ACCESSOR (codenode)) {
												ValaBlock* _tmp10_;
												body = (_tmp10_ = _vala_code_node_ref0 (vala_property_accessor_get_body (VALA_PROPERTY_ACCESSOR (codenode))), _vala_code_node_unref0 (body), _tmp10_);
											} else {
												g_warning ("vscsymbolcompletion.vala:691: (get_codenode_body) unsupported type %s", g_type_name (G_TYPE_FROM_INSTANCE (codenode)));
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	result = body;
	return result;
}


static ValaDataType* vsc_symbol_completion_get_datatype_for_name_in_code_node_with_context (VscSymbolCompletion* self, ValaCodeNode* codenode, ValaCodeContext* context, const char* symbolname, ValaSourceFile* source, gint line, gint column, GError** error) {
	ValaDataType* result;
	GError * _inner_error_;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (codenode != NULL, NULL);
	g_return_val_if_fail (context != NULL, NULL);
	g_return_val_if_fail (symbolname != NULL, NULL);
	_inner_error_ = NULL;
	_tmp0_ = FALSE;
	if (_vala_strcmp0 (symbolname, "this") != 0) {
		_tmp0_ = _vala_strcmp0 (symbolname, "base") != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		ValaBlock* body;
		body = vsc_symbol_completion_get_codenode_body (self, codenode);
		if (body != NULL) {
			{
				GeeList* _tmp1_;
				GeeIterator* _tmp2_;
				GeeIterator* _lvar_it;
				_lvar_it = (_tmp2_ = gee_iterable_iterator ((GeeIterable*) (_tmp1_ = vala_block_get_local_variables (body))), _gee_collection_object_unref0 (_tmp1_), _tmp2_);
				while (TRUE) {
					ValaLocalVariable* lvar;
					if (!gee_iterator_next (_lvar_it)) {
						break;
					}
					lvar = (ValaLocalVariable*) gee_iterator_get (_lvar_it);
					if (_vala_strcmp0 (vala_symbol_get_name ((ValaSymbol*) lvar), symbolname) == 0) {
						gboolean _tmp3_;
						gboolean _tmp4_;
						_tmp3_ = FALSE;
						_tmp4_ = FALSE;
						if (vala_local_variable_get_variable_type (lvar) == NULL) {
							_tmp4_ = vala_local_variable_get_initializer (lvar) != NULL;
						} else {
							_tmp4_ = FALSE;
						}
						if (_tmp4_) {
							_tmp3_ = vala_expression_get_value_type (vala_local_variable_get_initializer (lvar)) != NULL;
						} else {
							_tmp3_ = FALSE;
						}
						if (_tmp3_) {
							result = _vala_code_node_ref0 (vala_expression_get_value_type (vala_local_variable_get_initializer (lvar)));
							_vala_code_node_unref0 (lvar);
							_gee_collection_object_unref0 (_lvar_it);
							_vala_code_node_unref0 (body);
							return result;
						} else {
							result = _vala_code_node_ref0 (vala_local_variable_get_variable_type (lvar));
							_vala_code_node_unref0 (lvar);
							_gee_collection_object_unref0 (_lvar_it);
							_vala_code_node_unref0 (body);
							return result;
						}
					}
					_vala_code_node_unref0 (lvar);
				}
				_gee_collection_object_unref0 (_lvar_it);
			}
			{
				GeeList* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _st_it;
				_st_it = (_tmp6_ = gee_iterable_iterator ((GeeIterable*) (_tmp5_ = vala_block_get_statements (body))), _gee_collection_object_unref0 (_tmp5_), _tmp6_);
				while (TRUE) {
					ValaStatement* st;
					if (!gee_iterator_next (_st_it)) {
						break;
					}
					st = (ValaStatement*) gee_iterator_get (_st_it);
					if (VALA_IS_DECLARATION_STATEMENT (st)) {
						ValaDeclarationStatement* decl;
						decl = _vala_code_node_ref0 (VALA_DECLARATION_STATEMENT (st));
						if (_vala_strcmp0 (vala_symbol_get_name (vala_declaration_statement_get_declaration (decl)), symbolname) == 0) {
							if (VALA_IS_LOCAL_VARIABLE (vala_declaration_statement_get_declaration (decl))) {
								ValaDataType* type;
								type = vsc_symbol_completion_datatype_for_localvariable (self, context, source, line, column, VALA_LOCAL_VARIABLE (vala_declaration_statement_get_declaration (decl)));
								if (type != NULL) {
									result = type;
									_vala_code_node_unref0 (decl);
									_vala_code_node_unref0 (st);
									_gee_collection_object_unref0 (_st_it);
									_vala_code_node_unref0 (body);
									return result;
								}
								_vala_code_node_unref0 (type);
							} else {
								g_warning ("vscsymbolcompletion.vala:720: (get_datatype_for_name_with_context) unsupported type %s for %s", g_type_name (G_TYPE_FROM_INSTANCE (codenode)), symbolname);
							}
						}
						_vala_code_node_unref0 (decl);
					}
					_vala_code_node_unref0 (st);
				}
				_gee_collection_object_unref0 (_st_it);
			}
			if (VALA_IS_METHOD (codenode)) {
				{
					GeeList* _tmp7_;
					GeeIterator* _tmp8_;
					GeeIterator* _par_it;
					_par_it = (_tmp8_ = gee_iterable_iterator ((GeeIterable*) (_tmp7_ = vala_method_get_parameters (VALA_METHOD (codenode)))), _gee_collection_object_unref0 (_tmp7_), _tmp8_);
					while (TRUE) {
						ValaFormalParameter* par;
						if (!gee_iterator_next (_par_it)) {
							break;
						}
						par = (ValaFormalParameter*) gee_iterator_get (_par_it);
						if (_vala_strcmp0 (vala_symbol_get_name ((ValaSymbol*) par), symbolname) == 0) {
							result = _vala_code_node_ref0 (vala_formal_parameter_get_parameter_type (par));
							_vala_code_node_unref0 (par);
							_gee_collection_object_unref0 (_par_it);
							_vala_code_node_unref0 (body);
							return result;
						}
						_vala_code_node_unref0 (par);
					}
					_gee_collection_object_unref0 (_par_it);
				}
			} else {
				if (VALA_IS_FOREACH_STATEMENT (codenode)) {
					ValaForeachStatement* fe;
					fe = _vala_code_node_ref0 (VALA_FOREACH_STATEMENT (codenode));
					if (_vala_strcmp0 (vala_foreach_statement_get_variable_name (fe), symbolname) == 0) {
						result = _vala_code_node_ref0 (vala_foreach_statement_get_type_reference (fe));
						_vala_code_node_unref0 (fe);
						_vala_code_node_unref0 (body);
						return result;
					}
					_vala_code_node_unref0 (fe);
				}
			}
		}
		_vala_code_node_unref0 (body);
	}
	if (vala_code_node_get_parent_node (codenode) != NULL) {
		ValaDataType* _tmp9_;
		_tmp9_ = vsc_symbol_completion_get_datatype_for_name_in_code_node_with_context (self, vala_code_node_get_parent_node (codenode), context, symbolname, source, line, column, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		result = _tmp9_;
		return result;
	} else {
		result = NULL;
		return result;
	}
}


static ValaDataType* vsc_symbol_completion_get_datatype_for_symbolname_with_context (VscSymbolCompletion* self, ValaCodeContext* context, const char* symbolname, ValaSourceFile* source, gint line, gint column, GError** error) {
	ValaDataType* result;
	GError * _inner_error_;
	ValaClass* cl;
	ValaMethod* md;
	ValaMethod* _tmp5_;
	ValaCodeNode* _tmp4_;
	ValaMethod* _tmp3_;
	ValaClass* _tmp2_;
	ValaCodeNode* _tmp1_;
	ValaClass* _tmp0_;
	ValaCodeNode* codenode;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (context != NULL, NULL);
	g_return_val_if_fail (symbolname != NULL, NULL);
	_inner_error_ = NULL;
	cl = NULL;
	md = NULL;
	_tmp3_ = NULL;
	_tmp0_ = NULL;
	codenode = (_tmp4_ = (_tmp1_ = vsc_symbol_completion_find_codenode (self, source, line, column, &_tmp0_, &_tmp3_, &_inner_error_), cl = (_tmp2_ = _tmp0_, _vala_code_node_unref0 (cl), _tmp2_), _tmp1_), md = (_tmp5_ = _tmp3_, _vala_code_node_unref0 (md), _tmp5_), _tmp4_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
			g_propagate_error (error, _inner_error_);
			_vala_code_node_unref0 (cl);
			_vala_code_node_unref0 (md);
			return NULL;
		} else {
			_vala_code_node_unref0 (cl);
			_vala_code_node_unref0 (md);
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	if (codenode != NULL) {
		ValaDataType* type;
		type = vsc_symbol_completion_get_datatype_for_name_in_code_node_with_context (self, codenode, context, symbolname, source, line, column, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
				g_propagate_error (error, _inner_error_);
				_vala_code_node_unref0 (cl);
				_vala_code_node_unref0 (md);
				_vala_code_node_unref0 (codenode);
				return NULL;
			} else {
				_vala_code_node_unref0 (cl);
				_vala_code_node_unref0 (md);
				_vala_code_node_unref0 (codenode);
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		if (type != NULL) {
			result = type;
			_vala_code_node_unref0 (cl);
			_vala_code_node_unref0 (md);
			_vala_code_node_unref0 (codenode);
			return result;
		}
		if (cl != NULL) {
			if (_vala_strcmp0 (symbolname, "this") == 0) {
				result = (ValaDataType*) vala_class_type_new (cl);
				_vala_code_node_unref0 (type);
				_vala_code_node_unref0 (cl);
				_vala_code_node_unref0 (md);
				_vala_code_node_unref0 (codenode);
				return result;
			} else {
				if (_vala_strcmp0 (symbolname, "base") == 0) {
					if (vala_class_get_base_class (cl) != NULL) {
						result = (ValaDataType*) vala_class_type_new (vala_class_get_base_class (cl));
						_vala_code_node_unref0 (type);
						_vala_code_node_unref0 (cl);
						_vala_code_node_unref0 (md);
						_vala_code_node_unref0 (codenode);
						return result;
					} else {
						{
							GeeList* _tmp6_;
							GeeIterator* _tmp7_;
							GeeIterator* _item_it;
							_item_it = (_tmp7_ = gee_iterable_iterator ((GeeIterable*) (_tmp6_ = vala_class_get_base_types (cl))), _gee_collection_object_unref0 (_tmp6_), _tmp7_);
							while (TRUE) {
								ValaDataType* item;
								if (!gee_iterator_next (_item_it)) {
									break;
								}
								item = (ValaDataType*) gee_iterator_get (_item_it);
								if (!VALA_IS_INTERFACE (item)) {
									result = item;
									_gee_collection_object_unref0 (_item_it);
									_vala_code_node_unref0 (type);
									_vala_code_node_unref0 (cl);
									_vala_code_node_unref0 (md);
									_vala_code_node_unref0 (codenode);
									return result;
								}
								_vala_code_node_unref0 (item);
							}
							_gee_collection_object_unref0 (_item_it);
						}
						result = NULL;
						_vala_code_node_unref0 (type);
						_vala_code_node_unref0 (cl);
						_vala_code_node_unref0 (md);
						_vala_code_node_unref0 (codenode);
						return result;
					}
				}
			}
			{
				GeeList* _tmp8_;
				GeeIterator* _tmp9_;
				GeeIterator* _field_it;
				_field_it = (_tmp9_ = gee_iterable_iterator ((GeeIterable*) (_tmp8_ = vala_class_get_fields (cl))), _gee_collection_object_unref0 (_tmp8_), _tmp9_);
				while (TRUE) {
					ValaField* field;
					if (!gee_iterator_next (_field_it)) {
						break;
					}
					field = (ValaField*) gee_iterator_get (_field_it);
					if (_vala_strcmp0 (vala_symbol_get_name ((ValaSymbol*) field), symbolname) == 0) {
						result = _vala_code_node_ref0 (vala_field_get_field_type (field));
						_vala_code_node_unref0 (field);
						_gee_collection_object_unref0 (_field_it);
						_vala_code_node_unref0 (type);
						_vala_code_node_unref0 (cl);
						_vala_code_node_unref0 (md);
						_vala_code_node_unref0 (codenode);
						return result;
					}
					_vala_code_node_unref0 (field);
				}
				_gee_collection_object_unref0 (_field_it);
			}
			{
				GeeList* _tmp10_;
				GeeIterator* _tmp11_;
				GeeIterator* _prop_it;
				_prop_it = (_tmp11_ = gee_iterable_iterator ((GeeIterable*) (_tmp10_ = vala_object_type_symbol_get_properties ((ValaObjectTypeSymbol*) cl))), _gee_collection_object_unref0 (_tmp10_), _tmp11_);
				while (TRUE) {
					ValaProperty* prop;
					if (!gee_iterator_next (_prop_it)) {
						break;
					}
					prop = (ValaProperty*) gee_iterator_get (_prop_it);
					if (_vala_strcmp0 (vala_symbol_get_name ((ValaSymbol*) prop), symbolname) == 0) {
						result = _vala_code_node_ref0 (vala_property_get_property_type (prop));
						_vala_code_node_unref0 (prop);
						_gee_collection_object_unref0 (_prop_it);
						_vala_code_node_unref0 (type);
						_vala_code_node_unref0 (cl);
						_vala_code_node_unref0 (md);
						_vala_code_node_unref0 (codenode);
						return result;
					}
					_vala_code_node_unref0 (prop);
				}
				_gee_collection_object_unref0 (_prop_it);
			}
			{
				GeeList* _tmp12_;
				GeeIterator* _tmp13_;
				GeeIterator* _clmt_it;
				_clmt_it = (_tmp13_ = gee_iterable_iterator ((GeeIterable*) (_tmp12_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) cl))), _gee_collection_object_unref0 (_tmp12_), _tmp13_);
				while (TRUE) {
					ValaMethod* clmt;
					if (!gee_iterator_next (_clmt_it)) {
						break;
					}
					clmt = (ValaMethod*) gee_iterator_get (_clmt_it);
					if (_vala_strcmp0 (vala_symbol_get_name ((ValaSymbol*) clmt), symbolname) == 0) {
						result = _vala_code_node_ref0 (vala_method_get_return_type (clmt));
						_vala_code_node_unref0 (clmt);
						_gee_collection_object_unref0 (_clmt_it);
						_vala_code_node_unref0 (type);
						_vala_code_node_unref0 (cl);
						_vala_code_node_unref0 (md);
						_vala_code_node_unref0 (codenode);
						return result;
					}
					_vala_code_node_unref0 (clmt);
				}
				_gee_collection_object_unref0 (_clmt_it);
			}
		}
		_vala_code_node_unref0 (type);
	} else {
		ValaClass* _tmp14_;
		ValaClass* _tmp15_;
		_tmp14_ = vsc_symbol_completion_get_class (self, source, line, column, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
				g_propagate_error (error, _inner_error_);
				_vala_code_node_unref0 (cl);
				_vala_code_node_unref0 (md);
				_vala_code_node_unref0 (codenode);
				return NULL;
			} else {
				_vala_code_node_unref0 (cl);
				_vala_code_node_unref0 (md);
				_vala_code_node_unref0 (codenode);
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		cl = (_tmp15_ = _tmp14_, _vala_code_node_unref0 (cl), _tmp15_);
	}
	result = NULL;
	_vala_code_node_unref0 (cl);
	_vala_code_node_unref0 (md);
	_vala_code_node_unref0 (codenode);
	return result;
}


static ValaDataType* vsc_symbol_completion_datatype_for_localvariable (VscSymbolCompletion* self, ValaCodeContext* context, ValaSourceFile* source, gint line, gint column, ValaLocalVariable* lv) {
	ValaDataType* result;
	ValaDataType* vt;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (context != NULL, NULL);
	g_return_val_if_fail (lv != NULL, NULL);
	g_warn_if_fail (self->priv->_parser != NULL);
	vt = NULL;
	_tmp0_ = FALSE;
	if (vala_local_variable_get_variable_type (lv) == NULL) {
		_tmp0_ = vala_local_variable_get_initializer (lv) != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		ValaDataType* _tmp1_;
		vt = (_tmp1_ = _vala_code_node_ref0 (vala_expression_get_value_type (vala_local_variable_get_initializer (lv))), _vala_code_node_unref0 (vt), _tmp1_);
		if (vt == NULL) {
			ValaExpression* initializer;
			char* class_name;
			char* member_name;
			initializer = _vala_code_node_ref0 (vala_local_variable_get_initializer (lv));
			class_name = NULL;
			member_name = NULL;
			if (VALA_IS_OBJECT_CREATION_EXPRESSION (initializer)) {
				ValaObjectCreationExpression* oce;
				oce = _vala_code_node_ref0 (VALA_OBJECT_CREATION_EXPRESSION (vala_local_variable_get_initializer (lv)));
				if (VALA_IS_MEMBER_ACCESS (vala_object_creation_expression_get_member_name (oce))) {
					ValaExpression* _tmp2_;
					initializer = (_tmp2_ = _vala_code_node_ref0 ((ValaExpression*) vala_object_creation_expression_get_member_name (oce)), _vala_code_node_unref0 (initializer), _tmp2_);
				}
				_vala_code_node_unref0 (oce);
			} else {
				if (VALA_IS_METHOD_CALL (initializer)) {
					ValaMethodCall* invoc;
					ValaExpression* _tmp3_;
					invoc = _vala_code_node_ref0 (VALA_METHOD_CALL (initializer));
					initializer = (_tmp3_ = _vala_code_node_ref0 (vala_method_call_get_call (invoc)), _vala_code_node_unref0 (initializer), _tmp3_);
					_vala_code_node_unref0 (invoc);
				}
			}
			if (VALA_IS_MEMBER_ACCESS (initializer)) {
				ValaMemberAccess* ma;
				gboolean _tmp4_;
				char* _tmp6_;
				ma = _vala_code_node_ref0 (VALA_MEMBER_ACCESS (initializer));
				_tmp4_ = FALSE;
				if (vala_member_access_get_inner (ma) != NULL) {
					_tmp4_ = vala_expression_get_symbol_reference (vala_member_access_get_inner (ma)) != NULL;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					char* _tmp5_;
					class_name = (_tmp5_ = vala_code_node_to_string ((ValaCodeNode*) vala_member_access_get_inner (ma)), _g_free0 (class_name), _tmp5_);
				}
				member_name = (_tmp6_ = g_strdup (vala_member_access_get_member_name (ma)), _g_free0 (member_name), _tmp6_);
				_vala_code_node_unref0 (ma);
			} else {
				if (VALA_IS_CAST_EXPRESSION (initializer)) {
					ValaCastExpression* ce;
					ValaDataType* _tmp7_;
					ce = _vala_code_node_ref0 (VALA_CAST_EXPRESSION (initializer));
					vt = (_tmp7_ = _vala_code_node_ref0 (vala_cast_expression_get_type_reference (ce)), _vala_code_node_unref0 (vt), _tmp7_);
					_vala_code_node_unref0 (ce);
				} else {
					g_warning ("vscsymbolcompletion.vala:837: (datatype_for_localvariable) initializer of type '%s' is not yet supported", g_type_name (G_TYPE_FROM_INSTANCE (initializer)));
				}
			}
			if (vt == NULL) {
				char* name;
				gboolean _tmp8_;
				VscTypeFinderVisitor* finder;
				ValaDataType* _tmp12_;
				name = NULL;
				_tmp8_ = FALSE;
				if (member_name != NULL) {
					_tmp8_ = class_name != NULL;
				} else {
					_tmp8_ = FALSE;
				}
				if (_tmp8_) {
					char* _tmp9_;
					name = (_tmp9_ = g_strdup_printf ("%s.%s", class_name, member_name), _g_free0 (name), _tmp9_);
				} else {
					if (class_name != NULL) {
						char* _tmp10_;
						name = (_tmp10_ = g_strdup (class_name), _g_free0 (name), _tmp10_);
					} else {
						char* _tmp11_;
						name = (_tmp11_ = g_strdup (member_name), _g_free0 (name), _tmp11_);
					}
				}
				finder = vsc_typefinder_visitor_new (NULL, NULL);
				vsc_typefinder_visitor_set_searched_typename (finder, name);
				vala_code_visitor_visit_namespace ((ValaCodeVisitor*) finder, vala_code_context_get_root (vsc_parser_manager_get_pri_context (self->priv->_parser)));
				vt = (_tmp12_ = vsc_symbol_completion_symbol_to_datatype (self, vsc_typefinder_visitor_get_result (finder)), _vala_code_node_unref0 (vt), _tmp12_);
				if (vt == NULL) {
					{
						GeeList* _tmp13_;
						GeeIterator* _tmp14_;
						GeeIterator* _item_it;
						_item_it = (_tmp14_ = gee_iterable_iterator ((GeeIterable*) (_tmp13_ = vala_source_file_get_using_directives (source))), _gee_collection_object_unref0 (_tmp13_), _tmp14_);
						while (TRUE) {
							ValaUsingDirective* item;
							char* using_name;
							if (!gee_iterator_next (_item_it)) {
								break;
							}
							item = (ValaUsingDirective*) gee_iterator_get (_item_it);
							using_name = g_strdup_printf ("%s.%s", vala_symbol_get_name (vala_using_directive_get_namespace_symbol (item)), name);
							vsc_typefinder_visitor_set_searched_typename (finder, using_name);
							vala_code_visitor_visit_namespace ((ValaCodeVisitor*) finder, vala_code_context_get_root (vsc_parser_manager_get_pri_context (self->priv->_parser)));
							if (vsc_typefinder_visitor_get_result (finder) != NULL) {
								ValaDataType* _tmp15_;
								vt = (_tmp15_ = vsc_symbol_completion_symbol_to_datatype (self, vsc_typefinder_visitor_get_result (finder)), _vala_code_node_unref0 (vt), _tmp15_);
								_vala_code_node_unref0 (item);
								_g_free0 (using_name);
								break;
							}
							_vala_code_node_unref0 (item);
							_g_free0 (using_name);
						}
						_gee_collection_object_unref0 (_item_it);
					}
					if (vt == NULL) {
						VscTypeFinderVisitor* _tmp16_;
						ValaDataType* _tmp17_;
						finder = (_tmp16_ = vsc_typefinder_visitor_new (source, vsc_parser_manager_get_pri_context (self->priv->_parser)), _vala_code_visitor_unref0 (finder), _tmp16_);
						vsc_typefinder_visitor_set_searched_typename (finder, name);
						vala_code_visitor_visit_namespace ((ValaCodeVisitor*) finder, vala_code_context_get_root (vsc_parser_manager_get_sec_context (self->priv->_parser)));
						vt = (_tmp17_ = vsc_symbol_completion_symbol_to_datatype (self, vsc_typefinder_visitor_get_result (finder)), _vala_code_node_unref0 (vt), _tmp17_);
					}
				}
				_g_free0 (name);
				_vala_code_visitor_unref0 (finder);
			}
			_vala_code_node_unref0 (initializer);
			_g_free0 (class_name);
			_g_free0 (member_name);
		}
	} else {
		if (vala_local_variable_get_variable_type (lv) != NULL) {
			ValaDataType* _tmp18_;
			vt = (_tmp18_ = _vala_code_node_ref0 (vala_local_variable_get_variable_type (lv)), _vala_code_node_unref0 (vt), _tmp18_);
			;
		}
	}
	result = vt;
	return result;
}


static gboolean vsc_symbol_completion_node_contains_position (VscSymbolCompletion* self, ValaCodeNode* node, gint line, gint column) {
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	_tmp0_ = FALSE;
	_tmp1_ = FALSE;
	_tmp2_ = FALSE;
	if (vala_source_reference_get_first_line (vala_code_node_get_source_reference (node)) < line) {
		_tmp2_ = vala_source_reference_get_last_line (vala_code_node_get_source_reference (node)) > line;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp3_;
		_tmp3_ = FALSE;
		if (vala_source_reference_get_first_line (vala_code_node_get_source_reference (node)) == line) {
			_tmp3_ = vala_source_reference_get_first_column (vala_code_node_get_source_reference (node)) <= column;
		} else {
			_tmp3_ = FALSE;
		}
		_tmp1_ = _tmp3_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp4_;
		_tmp4_ = FALSE;
		if (vala_source_reference_get_last_line (vala_code_node_get_source_reference (node)) == line) {
			_tmp4_ = vala_source_reference_get_last_column (vala_code_node_get_source_reference (node)) <= column;
		} else {
			_tmp4_ = FALSE;
		}
		_tmp0_ = _tmp4_;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static char* vsc_symbol_completion_normalize_typename (VscSymbolCompletion* self, const char* typename, const char* namespace_name) {
	char* result;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (typename != NULL, NULL);
	g_return_val_if_fail (namespace_name != NULL, NULL);
	if ((_tmp1_ = g_str_has_prefix (typename, _tmp0_ = g_strdup_printf ("%s.", namespace_name)), _g_free0 (_tmp0_), _tmp1_)) {
		result = g_strdup (typename);
		return result;
	} else {
		result = g_strdup_printf ("%s.%s", namespace_name, typename);
		return result;
	}
}


static char* vsc_symbol_completion_get_qualified_namespace_name (VscSymbolCompletion* self, ValaSymbol* namespace_symbol) {
	char* result;
	char* ns_name;
	ValaSymbol* ns;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (namespace_symbol != NULL, NULL);
	ns_name = NULL;
	ns = _vala_code_node_ref0 (namespace_symbol);
	while (TRUE) {
		gboolean _tmp0_;
		_tmp0_ = FALSE;
		if (ns != NULL) {
			_tmp0_ = vala_symbol_get_name (ns) != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		if (ns_name == NULL) {
			char* _tmp1_;
			ns_name = (_tmp1_ = g_strdup (vala_symbol_get_name (ns)), _g_free0 (ns_name), _tmp1_);
		} else {
			char* _tmp2_;
			ns_name = (_tmp2_ = g_strdup_printf ("%s.%s", vala_symbol_get_name (ns), ns_name), _g_free0 (ns_name), _tmp2_);
		}
		if (VALA_IS_UNRESOLVED_SYMBOL (ns)) {
			ValaSymbol* _tmp3_;
			ns = (_tmp3_ = _vala_code_node_ref0 ((ValaSymbol*) vala_unresolved_symbol_get_inner (VALA_UNRESOLVED_SYMBOL (ns))), _vala_code_node_unref0 (ns), _tmp3_);
		} else {
			ValaSymbol* _tmp4_;
			ns = (_tmp4_ = _vala_code_node_ref0 (vala_symbol_get_parent_symbol (ns)), _vala_code_node_unref0 (ns), _tmp4_);
		}
	}
	result = ns_name;
	_vala_code_node_unref0 (ns);
	return result;
}


VscSymbolCompletionResult* vsc_symbol_completion_get_completions_for_name (VscSymbolCompletion* self, VscSymbolCompletionFilterOptions* options, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error) {
	VscSymbolCompletionResult* result;
	GError * _inner_error_;
	VscSymbolCompletionResult* _result_;
	ValaSourceFile* source;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (options != NULL, NULL);
	g_return_val_if_fail (symbolname != NULL, NULL);
	_inner_error_ = NULL;
	g_warn_if_fail (self->priv->_parser != NULL);
	_result_ = vsc_symbol_completion_result_new ();
	source = NULL;
	if (sourcefile != NULL) {
		ValaSourceFile* _tmp0_;
		source = (_tmp0_ = vsc_symbol_completion_find_sourcefile (self, vsc_parser_manager_get_sec_context (self->priv->_parser), sourcefile), _vala_source_file_unref0 (source), _tmp0_);
		if (NULL == source) {
			ValaSourceFile* _tmp1_;
			source = (_tmp1_ = vsc_symbol_completion_find_sourcefile (self, vsc_parser_manager_get_pri_context (self->priv->_parser), sourcefile), _vala_source_file_unref0 (source), _tmp1_);
		}
	}
	vsc_parser_manager_lock_all_contexts (self->priv->_parser);
	{
		gboolean _tmp2_;
		VscTypeFinderVisitor* finder;
		VscCompletionVisitor* completion;
		gboolean _tmp22_;
		gboolean _tmp25_;
		gboolean _tmp26_;
		_tmp2_ = FALSE;
		if (options->local_variables) {
			_tmp2_ = source != NULL;
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			ValaClass* cl;
			ValaMethod* md;
			ValaMethod* _tmp8_;
			ValaCodeNode* _tmp7_;
			ValaMethod* _tmp6_;
			ValaClass* _tmp5_;
			ValaCodeNode* _tmp4_;
			ValaClass* _tmp3_;
			ValaCodeNode* codenode;
			cl = NULL;
			md = NULL;
			_tmp6_ = NULL;
			_tmp3_ = NULL;
			codenode = (_tmp7_ = (_tmp4_ = vsc_symbol_completion_find_codenode (self, source, line, column, &_tmp3_, &_tmp6_, &_inner_error_), cl = (_tmp5_ = _tmp3_, _vala_code_node_unref0 (cl), _tmp5_), _tmp4_), md = (_tmp8_ = _tmp6_, _vala_code_node_unref0 (md), _tmp8_), _tmp7_);
			if (_inner_error_ != NULL) {
				_vala_code_node_unref0 (cl);
				_vala_code_node_unref0 (md);
				goto __catch5_g_error;
				goto __finally5;
			}
			if (codenode != NULL) {
				ValaCodeNode* current;
				current = _vala_code_node_ref0 (codenode);
				g_debug ("vscsymbolcompletion.vala:950: local varialbles");
				while (TRUE) {
					ValaBlock* body;
					if (!(current != NULL)) {
						break;
					}
					body = vsc_symbol_completion_get_codenode_body (self, current);
					if (body != NULL) {
						{
							GeeList* _tmp9_;
							GeeIterator* _tmp10_;
							GeeIterator* _lvar_it;
							_lvar_it = (_tmp10_ = gee_iterable_iterator ((GeeIterable*) (_tmp9_ = vala_block_get_local_variables (body))), _gee_collection_object_unref0 (_tmp9_), _tmp10_);
							while (TRUE) {
								ValaLocalVariable* lvar;
								VscSymbolCompletionItem* _tmp11_;
								if (!gee_iterator_next (_lvar_it)) {
									break;
								}
								lvar = (ValaLocalVariable*) gee_iterator_get (_lvar_it);
								gee_collection_add ((GeeCollection*) _result_->others, _tmp11_ = vsc_symbol_completion_item_new (vala_symbol_get_name ((ValaSymbol*) lvar)));
								_g_object_unref0 (_tmp11_);
								_vala_code_node_unref0 (lvar);
							}
							_gee_collection_object_unref0 (_lvar_it);
						}
						{
							GeeList* _tmp12_;
							GeeIterator* _tmp13_;
							GeeIterator* _st_it;
							_st_it = (_tmp13_ = gee_iterable_iterator ((GeeIterable*) (_tmp12_ = vala_block_get_statements (body))), _gee_collection_object_unref0 (_tmp12_), _tmp13_);
							while (TRUE) {
								ValaStatement* st;
								if (!gee_iterator_next (_st_it)) {
									break;
								}
								st = (ValaStatement*) gee_iterator_get (_st_it);
								if (VALA_IS_DECLARATION_STATEMENT (st)) {
									ValaDeclarationStatement* decl;
									VscSymbolCompletionItem* _tmp14_;
									decl = _vala_code_node_ref0 (VALA_DECLARATION_STATEMENT (st));
									gee_collection_add ((GeeCollection*) _result_->others, _tmp14_ = vsc_symbol_completion_item_new (vala_symbol_get_name (vala_declaration_statement_get_declaration (decl))));
									_g_object_unref0 (_tmp14_);
									_vala_code_node_unref0 (decl);
								}
								_vala_code_node_unref0 (st);
							}
							_gee_collection_object_unref0 (_st_it);
						}
						if (VALA_IS_FOREACH_STATEMENT (current)) {
							ValaForeachStatement* fe;
							VscSymbolCompletionItem* _tmp15_;
							fe = _vala_code_node_ref0 (VALA_FOREACH_STATEMENT (current));
							gee_collection_add ((GeeCollection*) _result_->others, _tmp15_ = vsc_symbol_completion_item_new (vala_foreach_statement_get_variable_name (fe)));
							_g_object_unref0 (_tmp15_);
							_vala_code_node_unref0 (fe);
						}
					}
					if (VALA_IS_METHOD (current)) {
						{
							GeeList* _tmp16_;
							GeeIterator* _tmp17_;
							GeeIterator* _par_it;
							_par_it = (_tmp17_ = gee_iterable_iterator ((GeeIterable*) (_tmp16_ = vala_method_get_parameters (VALA_METHOD (current)))), _gee_collection_object_unref0 (_tmp16_), _tmp17_);
							while (TRUE) {
								ValaFormalParameter* par;
								VscSymbolCompletionItem* _tmp18_;
								if (!gee_iterator_next (_par_it)) {
									break;
								}
								par = (ValaFormalParameter*) gee_iterator_get (_par_it);
								gee_collection_add ((GeeCollection*) _result_->others, _tmp18_ = vsc_symbol_completion_item_new (vala_symbol_get_name ((ValaSymbol*) par)));
								_g_object_unref0 (_tmp18_);
								_vala_code_node_unref0 (par);
							}
							_gee_collection_object_unref0 (_par_it);
						}
						_vala_code_node_unref0 (body);
						break;
					} else {
						ValaCodeNode* _tmp19_;
						current = (_tmp19_ = _vala_code_node_ref0 (vala_code_node_get_parent_node (current)), _vala_code_node_unref0 (current), _tmp19_);
					}
					_vala_code_node_unref0 (body);
				}
				_vala_code_node_unref0 (current);
			}
			_vala_code_node_unref0 (cl);
			_vala_code_node_unref0 (md);
			_vala_code_node_unref0 (codenode);
		}
		finder = vsc_typefinder_visitor_new (source, vsc_parser_manager_get_pri_context (self->priv->_parser));
		completion = vsc_completion_visitor_new (options, _result_, source, vsc_parser_manager_get_pri_context (self->priv->_parser));
		if (source != NULL) {
			{
				GeeList* _tmp20_;
				GeeIterator* _tmp21_;
				GeeIterator* _node_it;
				_node_it = (_tmp21_ = gee_iterable_iterator ((GeeIterable*) (_tmp20_ = vala_source_file_get_nodes (source))), _gee_collection_object_unref0 (_tmp20_), _tmp21_);
				while (TRUE) {
					ValaCodeNode* node;
					if (!gee_iterator_next (_node_it)) {
						break;
					}
					node = (ValaCodeNode*) gee_iterator_get (_node_it);
					if (VALA_IS_NAMESPACE (node)) {
						ValaNamespace* ns;
						char* ns_name;
						char* name;
						ns = _vala_code_node_ref0 (VALA_NAMESPACE (node));
						ns_name = vsc_symbol_completion_get_qualified_namespace_name (self, (ValaSymbol*) ns);
						name = vsc_symbol_completion_normalize_typename (self, symbolname, ns_name);
						vsc_typefinder_visitor_set_searched_typename (finder, name);
						vala_code_visitor_visit_namespace ((ValaCodeVisitor*) finder, ns);
						if (vsc_typefinder_visitor_get_result (finder) != NULL) {
							vala_code_node_accept ((ValaCodeNode*) vsc_typefinder_visitor_get_result (finder), (ValaCodeVisitor*) completion);
							if (VALA_IS_NAMESPACE (vsc_typefinder_visitor_get_result (finder))) {
								vsc_symbol_completion_get_completion_for_name_in_namespace_with_context (self, ns_name, symbolname, finder, completion, vsc_parser_manager_get_pri_context (self->priv->_parser));
							}
							_vala_code_node_unref0 (ns);
							_g_free0 (ns_name);
							_g_free0 (name);
							_vala_code_node_unref0 (node);
							break;
						} else {
							gint tmp;
							tmp = vsc_symbol_completion_result_get_count (_result_);
							vsc_symbol_completion_get_completion_for_name_in_namespace_with_context (self, ns_name, symbolname, finder, completion, vsc_parser_manager_get_pri_context (self->priv->_parser));
							if (tmp != vsc_symbol_completion_result_get_count (_result_)) {
								_vala_code_node_unref0 (ns);
								_g_free0 (ns_name);
								_g_free0 (name);
								_vala_code_node_unref0 (node);
								break;
							}
						}
						_vala_code_node_unref0 (ns);
						_g_free0 (ns_name);
						_g_free0 (name);
					}
					_vala_code_node_unref0 (node);
				}
				_gee_collection_object_unref0 (_node_it);
			}
		} else {
			g_warning ("vscsymbolcompletion.vala:1014: no source file found");
		}
		if (vsc_typefinder_visitor_get_result (finder) == NULL) {
			vsc_typefinder_visitor_set_searched_typename (finder, symbolname);
			vala_code_visitor_visit_namespace ((ValaCodeVisitor*) finder, vala_code_context_get_root (vsc_parser_manager_get_pri_context (self->priv->_parser)));
			if (vsc_typefinder_visitor_get_result (finder) != NULL) {
				vala_code_node_accept ((ValaCodeNode*) vsc_typefinder_visitor_get_result (finder), (ValaCodeVisitor*) completion);
			}
		}
		g_debug ("vscsymbolcompletion.vala:1027: import symbols from the imported namespaces");
		_tmp22_ = FALSE;
		if (source != NULL) {
			_tmp22_ = options->imported_namespaces;
		} else {
			_tmp22_ = FALSE;
		}
		if (_tmp22_) {
			char* prev_symbol;
			prev_symbol = g_strdup (vsc_typefinder_visitor_get_searched_typename (finder));
			{
				GeeList* _tmp23_;
				GeeIterator* _tmp24_;
				GeeIterator* _item_it;
				_item_it = (_tmp24_ = gee_iterable_iterator ((GeeIterable*) (_tmp23_ = vala_source_file_get_using_directives (source))), _gee_collection_object_unref0 (_tmp23_), _tmp24_);
				while (TRUE) {
					ValaUsingDirective* item;
					char* ns_name;
					if (!gee_iterator_next (_item_it)) {
						break;
					}
					item = (ValaUsingDirective*) gee_iterator_get (_item_it);
					ns_name = vsc_symbol_completion_get_qualified_namespace_name (self, vala_using_directive_get_namespace_symbol (item));
					vsc_typefinder_visitor_set_searched_typename (finder, ns_name);
					vsc_symbol_completion_get_completion_for_name_in_namespace_with_context (self, ns_name, ns_name, finder, completion, vsc_parser_manager_get_pri_context (self->priv->_parser));
					_vala_code_node_unref0 (item);
					_g_free0 (ns_name);
				}
				_gee_collection_object_unref0 (_item_it);
			}
			vsc_typefinder_visitor_set_searched_typename (finder, prev_symbol);
			_g_free0 (prev_symbol);
		}
		g_debug ("vscsymbolcompletion.vala:1040: search it in referenced namespaces");
		_tmp25_ = FALSE;
		_tmp26_ = FALSE;
		if (source != NULL) {
			_tmp26_ = vsc_typefinder_visitor_get_result (finder) == NULL;
		} else {
			_tmp26_ = FALSE;
		}
		if (_tmp26_) {
			_tmp25_ = !vsc_symbol_completion_symbol_has_known_namespace (symbolname);
		} else {
			_tmp25_ = FALSE;
		}
		if (_tmp25_) {
			gboolean force_exit;
			force_exit = FALSE;
			{
				GeeList* _tmp27_;
				GeeIterator* _tmp28_;
				GeeIterator* _item_it;
				_item_it = (_tmp28_ = gee_iterable_iterator ((GeeIterable*) (_tmp27_ = vala_source_file_get_using_directives (source))), _gee_collection_object_unref0 (_tmp27_), _tmp28_);
				while (TRUE) {
					ValaUsingDirective* item;
					gint tmp;
					char* ns_name;
					char* _tmp29_;
					gboolean _tmp30_;
					gboolean _tmp31_;
					if (!gee_iterator_next (_item_it)) {
						break;
					}
					item = (ValaUsingDirective*) gee_iterator_get (_item_it);
					tmp = vsc_symbol_completion_result_get_count (_result_);
					ns_name = vsc_symbol_completion_get_qualified_namespace_name (self, vala_using_directive_get_namespace_symbol (item));
					if ((_tmp30_ = g_str_has_prefix (symbolname, _tmp29_ = g_strdup_printf ("%s.", ns_name)), _g_free0 (_tmp29_), _tmp30_)) {
						force_exit = TRUE;
					}
					vsc_symbol_completion_get_completion_for_name_in_namespace_with_context (self, ns_name, symbolname, finder, completion, vsc_parser_manager_get_pri_context (self->priv->_parser));
					_tmp31_ = FALSE;
					if (tmp != vsc_symbol_completion_result_get_count (_result_)) {
						_tmp31_ = TRUE;
					} else {
						_tmp31_ = force_exit;
					}
					if (_tmp31_) {
						_vala_code_node_unref0 (item);
						_g_free0 (ns_name);
						break;
					}
					_vala_code_node_unref0 (item);
					_g_free0 (ns_name);
				}
				_gee_collection_object_unref0 (_item_it);
			}
		}
		_vala_code_visitor_unref0 (finder);
		_vala_code_visitor_unref0 (completion);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			_inner_error_ = _g_error_copy0 (err);
			if (_inner_error_ != NULL) {
				_g_error_free0 (err);
				_g_object_unref0 (_result_);
				_vala_source_file_unref0 (source);
				goto __finally5;
			}
			_g_error_free0 (err);
		}
	}
	__finally5:
	{
		vsc_parser_manager_unlock_all_contexts (self->priv->_parser);
	}
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_result_);
		_vala_source_file_unref0 (source);
		return NULL;
	}
	result = _result_;
	_vala_source_file_unref0 (source);
	return result;
}


static void vsc_symbol_completion_get_completion_for_name_in_namespace_with_context (VscSymbolCompletion* self, const char* namespace_name, const char* typename, VscTypeFinderVisitor* finder, VscCompletionVisitor* completion, ValaCodeContext* context) {
	gint _tmp1__length1;
	char** _tmp1_;
	char** _tmp0_;
	char* _tmp2_;
	char* ns_name;
	g_return_if_fail (self != NULL);
	g_return_if_fail (namespace_name != NULL);
	g_return_if_fail (typename != NULL);
	g_return_if_fail (finder != NULL);
	g_return_if_fail (completion != NULL);
	g_return_if_fail (context != NULL);
	ns_name = (_tmp2_ = g_strdup ((_tmp1_ = _tmp0_ = g_strsplit (namespace_name, ".", 2), _tmp1__length1 = _vala_array_length (_tmp0_), _tmp1_)[0]), _tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL), _tmp2_);
	{
		GeeList* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _ns_it;
		_ns_it = (_tmp4_ = gee_iterable_iterator ((GeeIterable*) (_tmp3_ = vala_namespace_get_namespaces (vala_code_context_get_root (context)))), _gee_collection_object_unref0 (_tmp3_), _tmp4_);
		while (TRUE) {
			ValaNamespace* ns;
			if (!gee_iterator_next (_ns_it)) {
				break;
			}
			ns = (ValaNamespace*) gee_iterator_get (_ns_it);
			if (_vala_strcmp0 (vala_symbol_get_name ((ValaSymbol*) ns), ns_name) == 0) {
				gboolean same_namespace;
				same_namespace = FALSE;
				if (_vala_strcmp0 (typename, namespace_name) == 0) {
					if (strstr (namespace_name, ".") == NULL) {
						same_namespace = TRUE;
					} else {
						vsc_typefinder_visitor_set_searched_typename (finder, namespace_name);
					}
				} else {
					char* _tmp5_;
					vsc_typefinder_visitor_set_searched_typename (finder, _tmp5_ = g_strdup_printf ("%s.%s", namespace_name, typename));
					_g_free0 (_tmp5_);
				}
				if (same_namespace) {
					vsc_completion_visitor_integrate_completion (completion, (ValaSymbol*) ns);
				} else {
					vala_code_visitor_visit_namespace ((ValaCodeVisitor*) finder, ns);
					if (vsc_typefinder_visitor_get_result (finder) != NULL) {
						vsc_completion_visitor_integrate_completion (completion, vsc_typefinder_visitor_get_result (finder));
					}
				}
				_vala_code_node_unref0 (ns);
				break;
			}
			_vala_code_node_unref0 (ns);
		}
		_gee_collection_object_unref0 (_ns_it);
	}
	_g_free0 (ns_name);
}


gboolean vsc_symbol_completion_symbol_has_known_namespace (const char* name) {
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (name != NULL, FALSE);
	_tmp0_ = FALSE;
	_tmp1_ = FALSE;
	if (g_str_has_prefix (name, "GLib.")) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = g_str_has_prefix (name, "Gtk.");
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_str_has_prefix (name, "Gdk.");
	}
	result = _tmp0_;
	return result;
}


VscSymbolCompletion* vsc_symbol_completion_construct (GType object_type) {
	VscSymbolCompletion * self;
	self = (VscSymbolCompletion*) g_object_new (object_type, NULL);
	return self;
}


VscSymbolCompletion* vsc_symbol_completion_new (void) {
	return vsc_symbol_completion_construct (VSC_TYPE_SYMBOL_COMPLETION);
}


VscParserManager* vsc_symbol_completion_get_parser (VscSymbolCompletion* self) {
	VscParserManager* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_parser;
	return result;
}


static void vsc_symbol_completion_class_init (VscSymbolCompletionClass * klass) {
	vsc_symbol_completion_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VscSymbolCompletionPrivate));
	G_OBJECT_CLASS (klass)->get_property = vsc_symbol_completion_get_property;
	G_OBJECT_CLASS (klass)->finalize = vsc_symbol_completion_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSC_SYMBOL_COMPLETION_PARSER, g_param_spec_object ("parser", "parser", "parser", VSC_TYPE_PARSER_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vsc_symbol_completion_instance_init (VscSymbolCompletion * self) {
	self->priv = VSC_SYMBOL_COMPLETION_GET_PRIVATE (self);
	self->priv->_parser = vsc_parser_manager_new ();
}


static void vsc_symbol_completion_finalize (GObject* obj) {
	VscSymbolCompletion * self;
	self = VSC_SYMBOL_COMPLETION (obj);
	_g_object_unref0 (self->priv->_parser);
	G_OBJECT_CLASS (vsc_symbol_completion_parent_class)->finalize (obj);
}


GType vsc_symbol_completion_get_type (void) {
	static GType vsc_symbol_completion_type_id = 0;
	if (vsc_symbol_completion_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (VscSymbolCompletionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsc_symbol_completion_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VscSymbolCompletion), 0, (GInstanceInitFunc) vsc_symbol_completion_instance_init, NULL };
		vsc_symbol_completion_type_id = g_type_register_static (G_TYPE_OBJECT, "VscSymbolCompletion", &g_define_type_info, 0);
	}
	return vsc_symbol_completion_type_id;
}


static void vsc_symbol_completion_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VscSymbolCompletion * self;
	self = VSC_SYMBOL_COMPLETION (object);
	switch (property_id) {
		case VSC_SYMBOL_COMPLETION_PARSER:
		g_value_set_object (value, vsc_symbol_completion_get_parser (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




